/* Tetris clone made by Grzegorz Adam Hankiewicz in May of 1997.
 * You can find me at http://web.jet.es/gregorio. Email: gregorio@jet.es
 * Visit Gogosoftware at http://gogosoftware.base.org
 *
 * This game would not exist if it was not for Allegro, the wonderful
 * game library made by Shawn Hargreaves. You can contact Shawn at
 * http://www.talula.demon.co.uk/ . The email is : shawn@talula.demon.co.uk
 *
 * This code is free. You can do whatever you want with it.
 * NOTE: This was my first game and it is written poorly, without enough re-
 * marks to understand the game, and some things don't work, like the sta-
 * tistics functions.
 *
 * PLEASE DON'T TRY TO LEARN FROM THIS, AND IF YOU DO, I DO NOT MAKE MYSELF
 * RESPONSIBLE FOR THE BAD SKILLS YOU WILL GET.
 *
 * What you need : Allegro (of course) and the DJGPP compiler which you can
 * find at http://www.delorie.com
 * It's recommended to also use RHIDE.
 *
 * To run the game you will need at least a 486/DX66, a SVGA card and like 3
 * or 4 megs or ram.We will use the 640x480x256 resolution as a basis. It is
 * left to the newbie to modify this to allow higher resolutions, and even-
 * tually allow more players (like 4) to play at the same computer
 *
 * The Tetris game is very well known, however, maybe you just woke up from
 * a cryogenig pod (like Conrad B. Hart :-) or have lost your memmory in a
 * Starship accident (Lev Arris, Privateer 2) this is it.
 *
 * You have a fixed screen, 10 units wide and 20 high. Some 'blocks' with
 * different forms fall, and you have to put them in such a way you 'fill'
 * a line. Then, this line will be deleted, allowing the player to continue
 * the game before the screen fills up. Every level, the 'blocks' will fall
 * faster and faster, until either the computer or the player explode ;-)
 *
 * We will start with a usual screen where you can configure the keys and
 * where you choose to play 1 or 2 players at the same time. There will be
 * cool? music and some FX.
 *
 * Ready? Then, fasten your seabelts :)
 */

#include<stdio.h>
#include<allegro.h> // Needed header to use Allegro
#include"tetris.h"  // Header file from the grabber
#include"lib.h"		// Functions I always use

// number of ticks a second has...
#define SECOND 30

/*
 * First we declare the global variables and create some pointers we will
 * later use for the graphics, sound, etc.
 */


/* These are the arrays od the pieces. We will give a minimum of 2 different
 * piece positions to every block and a maximum of 4. Each frame has a size
 * of 4x4. The value fames_name_of_block contains the number of frames the
 * array stores.
 */
char ficha_o[2][4][4]={1,1,0,0,
                      1,1,0,0,
                      0,0,0,0,
                      0,0,0,0,
                      1,1,0,0,
                      1,1,0,0,
                      0,0,0,0,
                      0,0,0,0,
                      };
char frames_o=2;
char ficha_z[2][4][4]={2,2,0,0,
                      0,2,2,0,
                      0,0,0,0,
                      0,0,0,0,
                      0,2,0,0,
                      2,2,0,0,
                      2,0,0,0,
                      0,0,0,0};
char frames_z=2;
char ficha_s[2][4][4]={0,3,3,0,
                      3,3,0,0,
                      0,0,0,0,
                      0,0,0,0,
                      3,0,0,0,
                      3,3,0,0,
                      0,3,0,0,
                      0,0,0,0};
char frames_s=2;
char ficha_l[2][4][4]={0,0,0,0,
                      5,5,5,5,
                      0,0,0,0,
                      0,0,0,0,
                      0,5,0,0,
                      0,5,0,0,
                      0,5,0,0,
                      0,5,0,0};
char frames_l=2;
char ficha_c[4][4][4]={4,4,4,0,
                      0,4,0,0,
                      0,0,0,0,
                      0,0,0,0,
                      0,4,0,0,
                      0,4,4,0,
                      0,4,0,0,
                      0,0,0,0,
                      0,4,0,0,
                      4,4,4,0,
                      0,0,0,0,
                      0,0,0,0,
                      0,4,0,0,
                      4,4,0,0,
                      0,4,0,0,
                      0,0,0,0};
char frames_c=4;
char ficha_j[4][4][4]={6,6,6,0,
                      6,0,0,0,
                      0,0,0,0,
                      0,0,0,0,
                      6,0,0,0,
                      6,0,0,0,
                      6,6,0,0,
                      0,0,0,0,
                      0,0,6,0,
                      6,6,6,0,
                      0,0,0,0,
                      0,0,0,0,
                      6,6,0,0,
                      0,6,0,0,
                      0,6,0,0,
                      0,0,0,0};
char frames_j=4;
char ficha_i[4][4][4]={7,0,0,0,
                      7,7,7,0,
                      0,0,0,0,
                      0,0,0,0,
                      0,7,0,0,
                      0,7,0,0,
                      7,7,0,0,
                      0,0,0,0,
                      7,7,7,0,
                      0,0,7,0,
                      0,0,0,0,
                      0,0,0,0,
                      7,7,0,0,
                      7,0,0,0,
                      7,0,0,0,
                      0,0,0,0};
char frames_i=4;

/* ficha_prox is the array of the piece which is showed to the player and
 * which will come next. We define one for every player
 */
char ficha_prox[4][4][4]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char frames_prox=0;
char ficha[4][4][4]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int frame,frames_ficha=0;
char ficha_prox_2[4][4][4]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char frames_prox_2=0;
char ficha_2[4][4][4]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int frame_2,frames_ficha_2=0;

/* vacio_1 and vacio_2 are the arenas of each player. old_vacio_1 and 2 are
 * buffers where we will store the actual screen appearence. Thanks to this,
 * the engine knows which part of the screen has to updated, and we will avoid
 * drawing a lot. Good for old/slow computers.
 */
char vacio_1[21][12]={10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10};
char vacio_2[21][12]={10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10,
                    10,10,10,10,10,10,10,10,10,10,10,10};
char old_vacio_1[21][12],old_vacio_2[21][12];


/* This is the high scores table. We will use a multidimensional struct of
 * characters. We will store 30 for the name, 2 for the level, 6 for
 * the score and 3 for the lines. We will keep up to 10 players. Remember we
 * HAVE to add 1 to the char buffers because of the "end-string" character.
 */

struct {
	char name[31];
   int level;
   unsigned int score;
   int lines;
   } high_scores[10];

// We use the following to check the version
char version[20]="VER 1.1";

/* We will store the statistics of the players in a bidimensional array.
 * NOTE: Everything which has to do with statistics is remarked. Why? The code
 * IS so buggie that if you unremark the statistic functions and play the
 * game, you will see that they don't work correctly because of the bad
 * programming style.
 */

//unsigned int statistics[2][7];

/* We will create the buffers for the redefined keys, which already will be
 * 'filled' by the default keys. Remember that the key's values are stored as
 * scancodes, and readkey() doesn't return scancodes directly, but you will
 * see this later when we explain redefine_keys().
 */

// The values for the redefinables keys.
int TECLA_1_UP,TECLA_1_DOWN,TECLA_1_LEFT,TECLA_1_RIGHT,
	TECLA_2_UP,TECLA_2_DOWN,TECLA_2_LEFT,TECLA_2_RIGHT,
   TECLA_MUSIC,TECLA_PAUSE;


int level_1,lines_1,score_1,next_score_1,total_lines_1;
int level_2,lines_2,score_2,next_score_2,total_lines_2;

// The values for the sound.
int vol_fx,vol_midi;
int ficha_x1,ficha_y1,desp_x1,pierde_1=0,speed_1=30;
int ficha_x2,ficha_y2,desp_x2,pierde_2=0,speed_2=30;
int pierde_ambos=0,start,death_match,death_lines;
int count_old,count_old_2,visible_blocks;
float last_1,last_2;

// These point to the random table.
long random_counter_1,random_counter_2;
// And this is the random table.
char order_of_blocks[250000];

int pos_y,pos_x=200;
int which_music=0;

//We will print strings to these buffers so that we can later use textout()
char score_1_buf[20],lines_1_buf[30],level_1_buf[20],next_score_1_buf[25],
		total_lines_1_buf[35];
char score_2_buf[20],lines_2_buf[30],level_2_buf[20],next_score_2_buf[25],
		total_lines_2_buf[35];
char buffer_vol_fx[30],buffer_vol_midi[30],buffer_mode[30],buffer_blocks[30],
	buffer_death_lines[30],buffer_music_num[30],buffer_music_title[50];

// Along the game we will check this value to know which texts to print
int language;
char language_buf[30];

volatile int tick_counter;

DATAFILE *datafile;
BITMAP *virtual,*pause_screen,*background;
PALETTE pal_title,pal_pause;
RGB temp;

/*
 * Now we declare some routines. Don't try to undestrand them now
 * The most important functions are main(), from where we call one of the
 * loops: one_player or two_player. There we will check the position of the
 * blocks and we will update the screen for the players. main() is the last
 * routine of the source code.
 */

void hot_keys(void);
void music(int p);
void capture_screen(void);
void help(void);

/* This function is called to check if the player pressed one of the 'hot
 * keys' while playing or using the menus
 */
void hot_keys(void)
{
if(key[KEY_F1]) help();
if(key[KEY_F12] || key[KEY_F10]) {
	capture_screen();
   }
if(midi_pos==-1 || key[TECLA_MUSIC]) {
	music(0);
   }
if(key[KEY_F5]){
   vol_fx--;
	if(vol_fx<0)vol_fx=0;
   set_volume(vol_fx,vol_midi);
   stop_sample(datafile[MOVE].dat);
	play_sample(datafile[MOVE].dat,255,128,1000,0);
   clear_keybuf();
   }
if(key[KEY_F6]){
   vol_fx++;
	if(vol_fx>255)vol_fx=255;
   set_volume(vol_fx,vol_midi);
	stop_sample(datafile[MOVE].dat);
	play_sample(datafile[MOVE].dat,255,128,1000,0);
   clear_keybuf();
   }
if(key[KEY_F7]){
   vol_midi--;
	if(vol_midi<0)vol_midi=0;
   set_volume(vol_fx,vol_midi);
   clear_keybuf();
   }
if(key[KEY_F8]){
   vol_midi++;
	if(vol_midi>255)vol_midi=255;
   set_volume(vol_fx,vol_midi);
   clear_keybuf();
   }
}

void save_scores(void)
{
FILE *file = fopen("scores.cfg","wb");
if (file) {
	fwrite (&high_scores,sizeof(high_scores),1,file);
   fclose (file);
   if(language==ENG)printf("High scores table saved.\n\n\n");
   else printf("Tabla de records salvada.\n\n\n");
   }
else {
	if(language==ENG)printf("Scores couldn't be saved !!! \n\n\n");
   else printf(" Los records no se pudieron salvar !!!\n\n\n");
   }
}

void save_config(void)
{
FILE *file = fopen("config.cfg","wb");
if (file) {
   fwrite (&version,sizeof (version),1,file);
   fwrite (&TECLA_1_UP,sizeof (TECLA_1_UP),1,file);
   fwrite (&TECLA_1_DOWN,sizeof (TECLA_1_DOWN),1,file);
   fwrite (&TECLA_1_LEFT,sizeof (TECLA_1_LEFT),1,file);
   fwrite (&TECLA_1_RIGHT,sizeof (TECLA_1_RIGHT),1,file);
   fwrite (&TECLA_2_UP,sizeof (TECLA_2_UP),1,file);
   fwrite (&TECLA_2_DOWN,sizeof (TECLA_2_DOWN),1,file);
   fwrite (&TECLA_2_LEFT,sizeof (TECLA_2_LEFT),1,file);
   fwrite (&TECLA_2_RIGHT,sizeof (TECLA_2_RIGHT),1,file);
   fwrite (&TECLA_MUSIC,sizeof (TECLA_MUSIC),1,file);
   fwrite (&TECLA_PAUSE,sizeof (TECLA_PAUSE),1,file);
   fwrite (&vol_fx,sizeof (vol_fx),1,file);
   fwrite (&vol_midi,sizeof (vol_midi),1,file);
   fwrite (&death_match,sizeof (death_match),1,file);
   fwrite (&death_lines,sizeof (death_lines),1,file);
   fwrite (&visible_blocks,sizeof (visible_blocks),1,file);
   fwrite (&language,sizeof(language),1,file);
   fclose (file);
   if(language==ENG) printf("Configuration saved.\n");
   else printf("Configuracin salvada.\n");
   }
else {
	if(language==ENG)printf("The configuration couldn't be saved !!! \n\n\n");
   else printf(" No se pudo salvar la configuracin !!! \n\n\n");
   }
}

// Looks for a config file. Restores default setting if unsuccesful
void init_config(void)
{
int f;
char temp_version[20];

FILE *file = fopen ("config.cfg", "rb");

if(file) {
	// Now we read the config file.
   fread (&temp_version,sizeof (temp_version),1,file);
   if (stricmp(temp_version, version) == 0) {
	   fread (&TECLA_1_UP,sizeof (TECLA_1_UP),1,file);
	   fread (&TECLA_1_DOWN,sizeof (TECLA_1_DOWN),1,file);
	   fread (&TECLA_1_LEFT,sizeof (TECLA_1_LEFT),1,file);
	   fread (&TECLA_1_RIGHT,sizeof (TECLA_1_RIGHT),1,file);
	   fread (&TECLA_2_UP,sizeof (TECLA_2_UP),1,file);
	   fread (&TECLA_2_DOWN,sizeof (TECLA_2_DOWN),1,file);
	   fread (&TECLA_2_LEFT,sizeof (TECLA_2_LEFT),1,file);
	   fread (&TECLA_2_RIGHT,sizeof (TECLA_2_RIGHT),1,file);
	   fread (&TECLA_MUSIC,sizeof (TECLA_MUSIC),1,file);
	   fread (&TECLA_PAUSE,sizeof (TECLA_PAUSE),1,file);
	   fread (&vol_fx,sizeof (vol_fx),1,file);
	   fread (&vol_midi,sizeof (vol_midi),1,file);
	   fread (&death_match,sizeof (death_match),1,file);
	   fread (&death_lines,sizeof (death_lines),1,file);
	   fread (&visible_blocks,sizeof (visible_blocks),1,file);
	   fread (&language,sizeof(language),1,file);
	   fclose (file);
      if(language==ENG)printf("Configuration file read without problems...");
	   else printf("Fichero de configuracin ledo sin problemas...");
   }
   else {
		TECLA_1_UP=17,TECLA_1_DOWN=31,TECLA_1_LEFT=30,TECLA_1_RIGHT=32,
		TECLA_2_UP=72,TECLA_2_DOWN=80,TECLA_2_LEFT=75,TECLA_2_RIGHT=77,
	   TECLA_MUSIC=50,TECLA_PAUSE=25;
	   vol_fx=255,vol_midi=225,death_match=1,death_lines=4,visible_blocks=1,
	   printf("Couldn't read configuration file.\nRestoring default settings...");
	   language=ask_language();
   	}
   }
else {
		TECLA_1_UP=17,TECLA_1_DOWN=31,TECLA_1_LEFT=30,TECLA_1_RIGHT=32,
		TECLA_2_UP=72,TECLA_2_DOWN=80,TECLA_2_LEFT=75,TECLA_2_RIGHT=77,
	   TECLA_MUSIC=50,TECLA_PAUSE=25;
	   vol_fx=255,vol_midi=225,death_match=1,death_lines=4,visible_blocks=1,
	   printf("Couldn't read configuration file.\nRestoring default settings...");
	   language=ask_language();
   }
}

/* Looks for existent captured screens files. Then saves the actual virtual
 * screen to a pcx file. If we wanted to save the REAL screen, this function
 * would be eternal with computers with slow video cards.
 */
void capture_screen(void){
int d;
char name[13];

for(d=0;d<999;d++){
	sprintf(name,"CAPT%d.PCX",d);
	if((exists(name))==0) {
      save_pcx(name,virtual,datafile[PAL_MAIN].dat);
      play_sample(datafile[MOVE].dat,255,128,1000,0);
      d+=1000;
      }
   }
}

// Looks for a scores table file. Restores default setting if unsuccesful
void init_scores(void)
{
int f;

FILE *file = fopen ("scores.cfg", "rb");

if(file) {
	// Now we read the scores.
   fread (&high_scores,sizeof (high_scores),1,file);
   fclose (file);
   if(language==ENG)printf("...high scores table read without problems...\n");
   else printf("...tabla de records leda sin problemas...\n");
   }
else {
	//If there's no scores file, we introduce default scores.
	for(f=9;f>=0;f--)	high_scores[f].level=10-f;
	high_scores[9].lines=10;
	for(f=8;f>=0;f--) high_scores[f].lines=high_scores[f+1].lines+10;
	for(f=9;f>=0;f--)	high_scores[f].score=high_scores[f].lines*10+high_scores[f].level*1000;

	sprintf(high_scores[0].name,"Grzegorz Adam Hankiewicz......");
	sprintf(high_scores[1].name,"Aritz Albaizar................");
	sprintf(high_scores[2].name,"DJ Delorie....................");
	sprintf(high_scores[3].name,"Shawn Hargreaves..............");
	sprintf(high_scores[4].name,"Rober Hhne...................");
	sprintf(high_scores[5].name,"Jagoba Sainz de Baranda.......");
	sprintf(high_scores[6].name,"Karolina Hankiewicz...........");
	sprintf(high_scores[7].name,"Wieslaw Hankiewicz............");
	sprintf(high_scores[8].name,"Enrique Cuenca Amigo..........");
	sprintf(high_scores[9].name,"Ion Toledo....................");
   if(language==ENG)printf("...couldn't read high scores file. Restoring default scores...\n");
   else printf("...no se pudo leer la tabla de records. Recuperando valores por defecto...\n");
   }
}

void print_high_scores(int number)
{
int f;

blit(background,virtual,0,0,0,0,640,480);
draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);

rectfill(virtual,55,106,585,367,0);
if(language==ENG){
   textout_centre(virtual,datafile[BIG_FONT].dat,"HALL OF FAME",320,110,8);
	textout(virtual,font,"NAME",135,145,8);
	textout(virtual,font,"SCORE",415,145,8);
	textout(virtual,font,"LEVEL",480,145,8);
	textout(virtual,font,"LINES",535,145,8);
   }
else {
   textout_centre(virtual,datafile[BIG_FONT].dat,"TABLA DE RECORDS",320,110,8);
	textout(virtual,font,"NOMBRE",135,145,8);
	textout(virtual,font,"PUNTOS",415,145,8);
	textout(virtual,font,"NIVEL",480,145,8);
	textout(virtual,font,"LINEAS",535,145,8);
   }

for (f=0;f<10;f++){
	sprintf(lines_1_buf,"%d.", f+1);
	textout(virtual,font,lines_1_buf,70,170+(f*20),1);
	textout(virtual,font,high_scores[f].name,120,170+(f*20),1);
	sprintf(lines_1_buf,"%d", high_scores[f].lines);
	sprintf(level_1_buf,"%d", high_scores[f].level);
	sprintf(score_1_buf,"%d", high_scores[f].score);
   textout(virtual,font,score_1_buf,415,170+(f*20),1);
   textout(virtual,font,level_1_buf,490,170+(f*20),1);
   textout(virtual,font,lines_1_buf,540,170+(f*20),1);
   }

	sprintf(lines_1_buf,"Lines to next level: %ld", lines_1);
	sprintf(total_lines_1_buf,"Total lines: %ld", total_lines_1);
	sprintf(level_1_buf,"Level: %ld", level_1);
	sprintf(score_1_buf,"Score: %ld", score_1);
if(number==1) {
	rectfill(virtual,55,381,585,405,0);
	if(language==ENG)textout(virtual,font,"Player 1",70,390,1);
   else textout(virtual,font,"Jugador 1",70,390,1);
	sprintf(score_1_buf,"%d", score_1);
	sprintf(level_1_buf,"%d", level_1);
	sprintf(lines_1_buf,"%d", total_lines_1);
   textout(virtual,font,score_1_buf,415,390,1);
   textout(virtual,font,level_1_buf,490,390,1);
   textout(virtual,font,lines_1_buf,540,390,1);
   }
if(number==2) {
	rectfill(virtual,55,381,585,405,0);
   if(language==ENG)textout(virtual,font,"Player 2",70,390,1);
   else textout(virtual,font,"Jugador 2",70,390,1);
	sprintf(score_1_buf,"%d", score_2);
	sprintf(level_1_buf,"%d", level_2);
	sprintf(lines_1_buf,"%d", total_lines_2);
   textout(virtual,font,score_1_buf,415,390,1);
   textout(virtual,font,level_1_buf,490,390,1);
   textout(virtual,font,lines_1_buf,540,390,1);
   }
if(number==3) {
	rectfill(virtual,55,381,585,425,0);
	if(score_1>=score_2) f=390;
   else f=410;
   if(language==ENG)textout(virtual,font,"Player 1",70,f,1);
   else textout(virtual,font,"Jugador 1",70,f,1);
	sprintf(score_1_buf,"%d", score_1);
	sprintf(level_1_buf,"%d", level_1);
	sprintf(lines_1_buf,"%d", total_lines_1);
   textout(virtual,font,score_1_buf,415,f,1);
   textout(virtual,font,level_1_buf,490,f,1);
   textout(virtual,font,lines_1_buf,540,f,1);
	if(score_1>=score_2) f=410;
   else f=390;
   if(language==ENG)textout(virtual,font,"Player 2",70,f,1);
   else textout(virtual,font,"Jugador 2",70,f,1);
	sprintf(score_1_buf,"%d", score_2);
	sprintf(level_1_buf,"%d", level_2);
	sprintf(lines_1_buf,"%d", total_lines_2);
   textout(virtual,font,score_1_buf,415,f,1);
   textout(virtual,font,level_1_buf,490,f,1);
   textout(virtual,font,lines_1_buf,540,f,1);
   }

blit(virtual,screen,0,0,0,0,640,480);
}

/* Switches the music to the specified number and prints the correct text to
 * the char buffers.
 */
void switch_music(int p){
char music[12];
char play[12];
char noname[12];

if(language==ENG) {
	sprintf(music,"MUSIC");
   sprintf(play,"PLAYING:");
   sprintf(noname,"UNTITLED");
   }
else {
	sprintf(music,"MUSICA");
   sprintf(play,"TOCANDO:");
   sprintf(noname,"SIN TITULO");
   }

switch(p){
	case 1:
     	play_midi(datafile[MUSIC1].dat,0);
      sprintf(buffer_music_num,"%s 1",music);
      sprintf(buffer_music_title,"%s WE ARE THE CHAMPIONS",play);
		break;
	case 2:
     	play_midi(datafile[MUSIC2].dat,0);
      sprintf(buffer_music_num,"%s 2",music);
      sprintf(buffer_music_title,"%s EYE OF THE TIGER",play);
		break;
	case 3:
     	play_midi(datafile[MUSIC3].dat,0);
      sprintf(buffer_music_num,"%s 3",music);
      sprintf(buffer_music_title,"%s ISN'T IT IRONIC",play);
		break;
	case 4:
      play_midi(datafile[MUSIC4].dat,0);
      sprintf(buffer_music_num,"%s 4",music);
      sprintf(buffer_music_title,"%s IMAGINE ALL THE PEOPLE",play);
		break;
	case 5:
     	play_midi(datafile[MUSIC5].dat,0);
      sprintf(buffer_music_num,"%s 5",music);
      sprintf(buffer_music_title,"%s %s",play,noname);
		break;
	case 6:
     	play_midi(datafile[MUSIC6].dat,0);
      sprintf(buffer_music_num,"%s 6",music);
      sprintf(buffer_music_title,"%s EVERY BREATH YOU TAKE",play);
		break;
	case 7:
     	play_midi(datafile[MUSIC7].dat,0);
      sprintf(buffer_music_num,"%s 7",music);
      sprintf(buffer_music_title,"%s ROXANNE",play);
		break;
	case 8:
     	play_midi(datafile[MUSIC8].dat,0);
      sprintf(buffer_music_num,"%s 8",music);
      sprintf(buffer_music_title,"%s %s",play,noname);
		break;
	}
}

/* If we call this routine with a zero value, it will choose one music at ran-
 * dom. If bigger/smaller than zero, it will choose the next/previous music.
 */
void music(int p){
int ran=random()%8;

if(p==0){

	do{
		ran=random()%8;
   	}while(which_music-1==ran);
   which_music=ran+1;
   switch_music(which_music);
	}

if(p>0 && which_music<8){
	which_music++;
   switch_music(which_music);
   play_sample(datafile[MOVE].dat,255,128,1000,0);
   }
if(p<0 && which_music>1){
	which_music--;
   switch_music(which_music);
	play_sample(datafile[MOVE].dat,255,128,1000,0);
   }
}

// Creates the pause screen with random pixels.
void create_pause_screen(void)
{
int x,y;

//We draw the pause screen wuth 4 different colours
for(y=0;y<480;y++)
	for(x=0;x<640;x++)
   	pause_screen->line[y][x]=random()%256;

// We set now the 16 different grayscale colors we will use.
for(y=0;y<256;y++){
	x=random()%256;
   pal_pause[y].r= x;
	pal_pause[y].g= x;
	pal_pause[y].b= x;
	}
}

/* Stores the timer values, just in case this function was called when playing,
 * and shows the quick help text.
 */
void help(void)
{
int timer_difference_1,timer_difference_2;

timer_difference_1=tick_counter-count_old;
timer_difference_2=tick_counter-count_old_2;

clear(screen);
if(language==ENG){
	textout_centre(screen,datafile[BIG_FONT].dat,"QUICK HELP SCREEN",320,10,21);
	textout(screen,font,"This is the quick help screen. You will have to read the 'README.TXT' file for",0,60,8);
	textout(screen,font,"detailed information. This help screen will tell you some basic things.",0,70,8);
	textout(screen,font,"The default keys for PLAYER 1 are A and S (move), S (drop) and W (rotate)",0,90,8);
	textout(screen,font,"The default keys for PLAYER 2 are the arrow keys. Use them like PLAYER 1.",0,100,8);
	textout(screen,font,"If you select a one player game, both the keys for PLAYER 1 and 2 can be used.",0,110,8);
	textout(screen,font,"Use the arrow keys to move through the menus of the game and press RETURN or",0,130,8);
	textout(screen,font,"SPACE BAR to select an option. Use the left and right arrow keys to modify an",0,140,8);
	textout(screen,font,"option.",0,150,8);
	textout(screen,font,"There are two modes to play TETRIS when two players are there: NORMAL MODE and",0,170,8);
	textout(screen,font,"DEATHMATCH MODE. When playing in NORMAL MODE, the actions of one player have no",0,180,8);
	textout(screen,font,"effect on what the other player is doing,but if you are playing DEATHMATCH MODE,",0,190,8);
	textout(screen,font,"when a player makes so many lines as the DEATH LINES value says, the 'ARENA'",0,200,8);
	textout(screen,font,"of the other player will GROW. Experiment with different number of DEATH LINES.",0,210,8);
	textout(screen,font,"The default number of DEATH LINES is set to 4, but this is quite slow. Advanced",0,220,8);
	textout(screen,font,"players should use 1 or 2 DEATH LINES. Then, the game is quicker and funnier.",0,230,8);
	textout(screen,font,"The keys and options are stored in a file named 'CONFIG.CFG'. If you delete it,",0,250,8);
	textout(screen,font,"the next time you start the game, it will restore the default settings. The same",0,260,8);
	textout(screen,font,"applies to the high scores, which are stored in the 'SCORES.CFG' file.",0,270,8);
	textout(screen,font,"There are several 'HOT KEYS' which can be used in nearly every part of the game",0,290,8);
	textout(screen,font,"(and now don't work) and these are :",0,300,8);
	textout(screen,font,"F1  : Brings you this quick help screen",0,320,8);
	textout(screen,font,"F5  : Decreases the sound volume of the special effects",0,330,8);
	textout(screen,font,"F6  : Increases the sound volume of the special effects",0,340,8);
	textout(screen,font,"F7  : Decreases the sound volume of the background music",0,350,8);
	textout(screen,font,"F8  : Increases the sound volume of the background music",0,360,8);
	textout(screen,font,"F10 : Saves the actual screen to a 'CAPTxxx.PCX' file. ",0,370,8);
	textout(screen,font,"F12 : Just like F10. Why does this exist? Because I always forgot which was the",0,380,8);
	textout(screen,font,"      capture screen key, and now I don't make any more mistakes ;-)",0,390,8);
	textout(screen,font,"There is also a default key (P) to pause the game, but you can redefine it. If",0,420,8);
	textout(screen,font,"the music bores you, press M (it is also redefineable) and it will change.",0,430,8);
	textout_centre(screen,datafile[BIG_FONT].dat,"PRESS ANY KEY TO EXIT FROM THIS SCREEN",320,450,21);
   }
else {
	textout_centre(screen,datafile[BIG_FONT].dat,"AYUDA RAPIDA",320,10,21);
	textout(screen,font,"Esto es una ayuda rpida. Tendrs que leer el fichero 'LEEME.TXT' para ms in-",0,60,8);
	textout(screen,font,"formacin detallada.  Esta pantalla te contar algunas cosas bsicas.",0,70,8);
	textout(screen,font,"Las teclas predefinidas del JUGADOR 1 son A y D (mover), S (bajar) y W (rotar)",0,90,8);
	textout(screen,font,"Las teclas predefinidas del JUGADOR 2 son los cursores.",0,100,8);
	textout(screen,font,"Si slo juega un jugador, los teclas del JUGADOR 1 y 2 sirven para jugar.",0,110,8);
	textout(screen,font,"Usa los cursores para moverte por los menus del juego y presiona RETURN o la",0,130,8);
	textout(screen,font,"BARRA ESPACIADORA para seleccionar una opcin. Mueve a derecha o izquierda pa-",0,140,8);
	textout(screen,font,"ra modificar alguna opcin.",0,150,8);
	textout(screen,font,"Hay dos modos de juego cuando 2 jugadores juegan a la vez: MODO NORMAL y MODO",0,170,8);
	textout(screen,font,"ASESINO. En el MODO NORMAL, lo que hace un jugador no influye sobre el otro,",0,180,8);
	textout(screen,font,"pero si el MODO ASESINO est activado, cuando un jugador haga tantas lneas como",0,190,8);
	textout(screen,font,"especifica el valor LINEAS DE LA MUERTE, el 'CAMPO DE JUEGO' del otro jugador",0,200,8);
	textout(screen,font,"CRECERA. Experimenta con diversos valores de LINEAS DE LA MUERTE. Por defecto,",0,210,8);
	textout(screen,font,"stas estan puestas a 4, pero esto es bastante lento. Los jugadores experimenta-",0,220,8);
	textout(screen,font,"dos deberan usar 1 o 2 LINEAS DE LA MUERTE. Entonces el juego es ms rpido.",0,230,8);
	textout(screen,font,"Las teclas y las opciones se salvan en el fichero 'CONFIG.CFG'. Si lo borras,",0,250,8);
	textout(screen,font,"la prxima vez que juegues, el juego recuperar los valores por defecto. Lo mis-",0,260,8);
	textout(screen,font,"mo ocurre con los records, que son salvados en el fichero 'SCORES.CFG'.",0,270,8);
	textout(screen,font,"Hay algunas 'TECLAS RAPIDAS' que se pueden usar durante casi todo el juego, (y",0,290,8);
	textout(screen,font,"que ahora no funcionan) y estas son :",0,300,8);
	textout(screen,font,"F1  : Muestra esta pantalla",0,320,8);
	textout(screen,font,"F5  : Decrementa el volumen sonoro de los efectos especiales",0,330,8);
	textout(screen,font,"F6  : Incrementa el volumen sonoro de los efectos especiales",0,340,8);
	textout(screen,font,"F7  : Decrementa el volumen sonoro de la msica de fondo",0,350,8);
	textout(screen,font,"F8  : Incrementa el volumen sonoro de la msica de fondo",0,360,8);
	textout(screen,font,"F10 : Salva la pantalla en un fichero 'CAPTxxx.PCX' . ",0,370,8);
	textout(screen,font,"F12 : Como F10. Por qu existe? Porque siempre me olvidaba cul era la tecla",0,380,8);
	textout(screen,font,"      para salvar la pantalla, y ahora no me puedo confundir ms ;-)",0,390,8);
	textout(screen,font,"Tambin hay una tecla predeterminada (P) que pausa el juego, pero puedes rede-",0,420,8);
	textout(screen,font,"finirla. Para cambiar la msica al azar, pulsa la M (se puede cambiar)",0,430,8);
	textout_centre(screen,datafile[BIG_FONT].dat,"PULSA UNA TECLA PARA SALIR DE AQUI",320,450,21);
   }

clear_keybuf();
do{
if(midi_pos==-1 || key[TECLA_MUSIC]) {
	music(0);
   }
}while(!keypressed());
clear_keybuf();

blit(virtual,screen,0,0,0,0,640,480);
count_old=tick_counter-timer_difference_1;
count_old_2=tick_counter-timer_difference_2;
}

// Saves timer values, shows the pause screen and rotates the pallete
void pausa(void)
{
int c,sample_counter,timer_difference_1,timer_difference_2;

timer_difference_1=tick_counter-count_old;
timer_difference_2=tick_counter-count_old_2;

set_pallete(black_pallete);
blit(pause_screen,screen,0,0,0,0,640,480);
while(key[TECLA_PAUSE]);

play_sample(datafile[RUIDO].dat,200,128,1000,1000);
sample_counter=tick_counter;
while(!key[TECLA_PAUSE] && !key[KEY_ESC])
	{
	temp=pal_pause[255];
   for(c=255;c>0;c--)
   	pal_pause[c]=pal_pause[c-1];
   pal_pause[0]=temp;
   set_pallete(pal_pause);
	if(sample_counter+3000<tick_counter){
      stop_sample(datafile[RUIDO].dat);
   	adjust_sample(datafile[RUIDO].dat,200,128,1000,1000);
      }
};
stop_sample(datafile[RUIDO].dat);
set_pallete(black_pallete);
blit(virtual,screen,0,0,0,0,640,480);
while(key[TECLA_PAUSE] || key[KEY_ESC]);

count_old=tick_counter-timer_difference_1;
count_old_2=tick_counter-timer_difference_2;
set_pallete(datafile[PAL_MAIN].dat);
}

/* A player got a high score. We read the keyboard input and modify the high
 * scores table.
 */
void got_score(int player)
{
char text[33];
int ch, l,x=320,y=220,score,level,lines;

if(player==1) {
	score=score_1;
   level=level_1;
   lines=total_lines_1;
   }

if(player==2) {
	score=score_2;
   level=level_2;
   lines=total_lines_2;
   }

//We clear the text buffer and put all '.'
for(l=0;l<33;l++) text[l]='\0';
for(l=0;l<30;l++) text[l]='.';
text[0]='-';
l=0;

blit(background,virtual,0,0,0,0,640,480);
if(language==ENG){
	if (player==1)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 1, ENTER YOUR NAME",320,160,8);
	if (player==2)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 2, ENTER YOUR NAME",320,160,8);
   }
else {
	if (player==1)textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 1, INTRODUCE TU NOMBRE",320,160,8);
	if (player==2)textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 2, INTRODUCE TU NOMBRE",320,160,8);
   }
textout_centre(virtual,datafile[BIG_FONT].dat,text,320,220,8);
clear_keybuf();
blit(virtual,screen,0,0,0,0,640,480);

while(1==1){
	if(keypressed()){
   	ch=readkey() & 0x00ff;
      if((ch>31)&&(ch<127) && l<30){
      	text[l+1]='-';
         text[l]=ch;
         l++;
			play_sample(datafile[MOVE].dat,255,128,1000,0);
         }
      else if((key[KEY_BACKSPACE]) && l>0 ){
      	l--;
         text[l+1]='.';
         text[l]='-';
			play_sample(datafile[MOVE].dat,255,128,1000,0);
         }
      else if(key[KEY_ENTER] || key[KEY_ESC]) break;

      else {
      	stop_sample(datafile[UNA_MAS].dat);
      	play_sample(datafile[UNA_MAS].dat,255,128,1000,0);
         }

		blit(background,virtual,0,220,0,220,640,40);
		textout_centre(virtual,datafile[BIG_FONT].dat,text,320,220,8);
		blit(virtual,screen,0,220,0,220,640,40);
		}
	}
play_sample(datafile[MOVE].dat,255,128,1000,0);
text[l]='.';

for(l=8;;l--){
	high_scores[l+1].score=high_scores[l].score;
	high_scores[l+1].level=high_scores[l].level;
	high_scores[l+1].lines=high_scores[l].lines;
   strcpy(high_scores[l+1].name,high_scores[l].name);

	if(score<high_scores[l].score) {
		strncpy (high_scores[l+1].name,text,30);
		high_scores[l+1].score=score;
		high_scores[l+1].level=level;
		high_scores[l+1].lines=lines;
      break;
      }
   if(l==0) {
		strncpy (high_scores[0].name,text,30);
		high_scores[0].score=score;
		high_scores[0].level=level;
		high_scores[0].lines=lines;
      break;
      }
	}
}

/*
// Update the statistics of the players. We substract 1 to player before using it
void update_statistics(int player)
{
int x,y,value=0;

for(x=0;x<3;x++)
	for(y=0;y<2;y++)
   	if(ficha[0][y][x]!=0) value=ficha[0][y][x];

statistics[player-1][value-1]++;
}

void show_statistics(int player)
{
int x,y,yb,xb,temp_pierde_1=pierde_1,temp_pierde_2=pierde_2;
struct {
	char buffer[20];
   } text[2][7];

pierde_1=0;
pierde_2=0;

// We will fill now the buffers with the correct text

for(x=0;x<2;x++)
	for(y=0;y<7;y++)
   	sprintf(text[x][y].buffer,"= %d", statistics[x][y]);

// First we clear the actual arenas.
for(yb=0;yb<20;yb++){
	for(xb=1;xb<11;xb++){
   	vacio_1[yb][xb]=0;
   	vacio_2[yb][xb]=0;
      }}

// ...and the old buffer
for(yb=0;yb<21;yb++){
	for(xb=0;xb<12;xb++){
		old_vacio_1[yb][xb]=10;
		old_vacio_2[yb][xb]=10;
      }}

//Now we set up the arenas to show the blocks and right to them, the statistics
for(y=0;y<4;y++){
   for(x=0;x<4;x++){
      ficha[0][y][x]=ficha_o[0][y][x];
      ficha_2[0][y][x]=ficha_o[0][y][x];
		}
	}
frame=0;ficha_y1=1;ficha_x1=2;frame_2=0;ficha_y2=1;ficha_x2=2;

dibuja_ficha();
dibuja_ficha_2();

for(y=0;y<4;y++){
   for(x=0;x<4;x++){
      ficha[0][y][x]=ficha_z[0][y][x];
      ficha_2[0][y][x]=ficha_z[0][y][x];
		}
	}
frame=0;ficha_y1=4;ficha_x1=2;frame_2=0;ficha_y2=4;ficha_x2=2;


dibuja_ficha();
dibuja_ficha_2();

for(y=0;y<4;y++){
   for(x=0;x<4;x++){
      ficha[0][y][x]=ficha_s[0][y][x];
      ficha_2[0][y][x]=ficha_s[0][y][x];
		}
	}
frame=0;ficha_y1=7;ficha_x1=2;frame_2=0;ficha_y2=7;ficha_x2=2;


dibuja_ficha();
dibuja_ficha_2();

for(y=0;y<4;y++){
   for(x=0;x<4;x++){
      ficha[0][y][x]=ficha_c[0][y][x];
      ficha_2[0][y][x]=ficha_c[0][y][x];
		}
	}
frame=0;ficha_y1=10;ficha_x1=2;frame_2=0;ficha_y2=10;ficha_x2=2;


dibuja_ficha();
dibuja_ficha_2();

for(y=0;y<4;y++){
   for(x=0;x<4;x++){
      ficha[0][y][x]=ficha_l[0][y][x];
      ficha_2[0][y][x]=ficha_l[0][y][x];
		}
	}
frame=0;ficha_y1=12;ficha_x1=2;frame_2=0;ficha_y2=12;ficha_x2=2;


dibuja_ficha();
dibuja_ficha_2();

for(y=0;y<4;y++){
   for(x=0;x<4;x++){
      ficha[0][y][x]=ficha_j[0][y][x];
      ficha_2[0][y][x]=ficha_j[0][y][x];
		}
	}
frame=0;ficha_y1=15;ficha_x1=2;frame_2=0;ficha_y2=15;ficha_x2=2;


dibuja_ficha();
dibuja_ficha_2();

for(y=0;y<4;y++){
   for(x=0;x<4;x++){
      ficha[0][y][x]=ficha_i[0][y][x];
      ficha_2[0][y][x]=ficha_i[0][y][x];
		}
	}
frame=0;ficha_y1=18;ficha_x1=2;frame_2=0;ficha_y2=18;ficha_x2=2;


dibuja_ficha();
dibuja_ficha_2();

// Now we will print the text buffers.

if(player>1) {
	dibuja_tablero_1();
   dibuja_tablero_2();
   }
else dibuja_tablero_1();

textout(screen,datafile[SMALL_FONT].dat,text[0][0].buffer,150,57,21);
textout(screen,datafile[SMALL_FONT].dat,text[0][1].buffer,150,122,21);
textout(screen,datafile[SMALL_FONT].dat,text[0][2].buffer,150,188,21);
textout(screen,datafile[SMALL_FONT].dat,text[0][3].buffer,150,255,21);
textout(screen,datafile[SMALL_FONT].dat,text[0][4].buffer,150,312,21);
textout(screen,datafile[SMALL_FONT].dat,text[0][5].buffer,150,363,21);
textout(screen,datafile[SMALL_FONT].dat,text[0][6].buffer,150,430,21);
if(player>1) {
	textout(screen,datafile[SMALL_FONT].dat,text[1][0].buffer,530,57,21);
	textout(screen,datafile[SMALL_FONT].dat,text[1][1].buffer,530,122,21);
	textout(screen,datafile[SMALL_FONT].dat,text[1][2].buffer,530,188,21);
	textout(screen,datafile[SMALL_FONT].dat,text[1][3].buffer,530,255,21);
	textout(screen,datafile[SMALL_FONT].dat,text[1][4].buffer,530,312,21);
	textout(screen,datafile[SMALL_FONT].dat,text[1][5].buffer,530,363,21);
	textout(screen,datafile[SMALL_FONT].dat,text[1][6].buffer,530,430,21);
   }

wait(-1,-1);

pierde_1=temp_pierde_1;
pierde_2=temp_pierde_2;
}
*/

/* Here starts the important thing. This is the loop we use when only one
 * player is playing.
 */

void one_player(void)
{
int f,xb,yb,last_move,last_rotate;

//We initialise the random table with values from 0-6.
random_counter_1=0;random_counter_2=0;
srandom(tick_counter);
for(yb=0;yb<250000;yb++)
	order_of_blocks[yb]=random()%7;

// Now we clean the arena
for(yb=0;yb<20;yb++)
	for(xb=1;xb<11;xb++)
		vacio_1[yb][xb]=0;
// ...and the old buffer
for(yb=0;yb<21;yb++)
	for(xb=0;xb<12;xb++)
		old_vacio_1[yb][xb]=10;

// We put some values to the default settings
lines_1=10;
total_lines_1=0;
score_1=0;
next_score_1=high_scores[9].score;
level_1=0;
start=0;

if(language==ENG){
	sprintf(lines_1_buf,"Lines to next level: %ld", lines_1);
	sprintf(total_lines_1_buf,"Total lines: %ld", total_lines_1);
	sprintf(level_1_buf,"Level: %ld", level_1);
	sprintf(score_1_buf,"Score: %ld", score_1);
	sprintf(next_score_1_buf,"Next High Score:%ld",high_scores[9].score);
	}
else {
	sprintf(lines_1_buf,"Lineas a completar: %ld", lines_1);
	sprintf(total_lines_1_buf,"Lineas totales: %ld", total_lines_1);
	sprintf(level_1_buf,"Nivel: %ld", level_1);
	sprintf(score_1_buf,"Puntos: %ld", score_1);
	sprintf(next_score_1_buf,"Proximo record:%ld",high_scores[9].score);
	}

ficha_nueva_1();
ficha_nueva_1();

/*
// Now we clean the statistics buffer
for(yb=0;yb<2;yb++)
	for(xb=0;xb<7;xb++)
   	statistics[yb][xb]=0;
*/

ficha_x1=5;ficha_y1=1;

clear_keybuf();
count_old=tick_counter;
last_move=tick_counter;
last_rotate=tick_counter;

pierde_ambos=0;
pierde_1=0,pierde_2=2;speed_1=30;

/* This prints the help box in the place where we would print the scores of
 * the second player*/
rectfill(virtual,232+19,300,232+19+130,400,0);
if(language==ENG) {
   textout(virtual,datafile[SMALL_FONT].dat,"Number of",22*11+19,305,21);
	textout(virtual,datafile[SMALL_FONT].dat,"  lines",22*11+19,320,21);
   textout(virtual,datafile[SMALL_FONT].dat,"             Points",22*11+19,312,21);
   }
else {
	textout(virtual,datafile[SMALL_FONT].dat,"Numero de",22*11+19,305,21);
	textout(virtual,datafile[SMALL_FONT].dat,"  lineas",22*11+19,320,21);
   textout(virtual,datafile[SMALL_FONT].dat,"             Puntos",22*11+19,312,21);
   }
textout(virtual,datafile[SMALL_FONT].dat,"   1           10",22*11+19,335,21);
textout(virtual,datafile[SMALL_FONT].dat,"   2           50",22*11+19,350,21);
textout(virtual,datafile[SMALL_FONT].dat,"   3           125",22*11+19,365,21);
textout(virtual,datafile[SMALL_FONT].dat,"   4           500",22*11+19,380,21);
blit(virtual,screen,251,285,251,285,388,286);

dibuja_ficha();
dibuja_tablero_1();


start++;
// Finally, this is the loop
while(!key[KEY_ESC] && pierde_1==0){
        hot_keys();
        if(key[TECLA_PAUSE]) pausa();
        if(key[TECLA_1_UP] && last_rotate<tick_counter ||
        		key[TECLA_2_UP] && last_rotate<tick_counter){
                choque_frame();
                last_rotate=tick_counter+5;
                }
        if(key[TECLA_1_DOWN] && count_old+1<tick_counter ||
        	key[TECLA_2_DOWN] && count_old+1<tick_counter) count_old-= speed_1;
        if(key[TECLA_1_RIGHT] && last_move<tick_counter ||
        	key[TECLA_2_RIGHT] && last_move<tick_counter){
                desp_x1=+1;
                choque_h();
                last_move=tick_counter+3;
                }
        if(key[TECLA_1_LEFT] && last_move<tick_counter ||
        	key[TECLA_2_LEFT] && last_move<tick_counter){
                desp_x1=-1;
                choque_h();
                last_move=tick_counter+3;
                }
        if(count_old+speed_1<tick_counter){
                choque_abajo();
                count_old=tick_counter;
                }
        }

//We look if we have to wait for the game over laugh to shut up
if(pierde_1!=0){
	clear_keybuf;
	count_old=tick_counter+(30*7.5);
	while(count_old>tick_counter);
   }

//show_statistics(1);

// Look at the player score. If good enough, call the got_score() routine
if(score_1>=high_scores[9].score){
	got_score(1);
	print_high_scores(0);
   }
else print_high_scores(1);

clear_keybuf();
while(!keypressed()) hot_keys();
stop_sample(datafile[RISA].dat);

}


void two_player(void)
{
// This is like one player, so don't expect too many coments ;-)

// First we initialise and erase the 'black' free space.
int f,xb,yb,last_move,last_rotate;
int f_2,last_move_2,last_rotate_2;

//We initialise the random table with values from 0-6.
random_counter_1=0;random_counter_2=0;
srandom(tick_counter);
for(yb=0;yb<250000;yb++)
	order_of_blocks[yb]=random()%7;

// Clean the arenas
for(yb=0;yb<20;yb++){
	for(xb=1;xb<11;xb++){
		vacio_1[yb][xb]=0;
		vacio_2[yb][xb]=0;
      }
   }
// ...and the old buffers
for(yb=0;yb<21;yb++){
	for(xb=0;xb<12;xb++){
		old_vacio_1[yb][xb]=10;
		old_vacio_2[yb][xb]=10;
      }
   }

lines_1=10;
total_lines_1=0;
score_1=0;
next_score_1=high_scores[9].score;
level_1=0;
lines_2=10;
total_lines_2=0;
score_2=0;
next_score_2=high_scores[9].score;
level_2=0;
last_1=0,last_2=0;

start=0;

if(language==ENG){
	sprintf(lines_1_buf,"Lines to next level: %ld", lines_1);
	sprintf(total_lines_1_buf,"Total lines: %ld", total_lines_1);
	sprintf(score_1_buf,"Score: %ld", score_1);
	sprintf(level_1_buf,"Level: %ld", level_1);
	sprintf(next_score_1_buf,"Next High Score:%ld",high_scores[9].score);
	sprintf(lines_2_buf,"Lines to next level: %ld", lines_2);
	sprintf(total_lines_2_buf,"Total lines: %ld", total_lines_2);
	sprintf(score_2_buf,"Score: %ld", score_2);
	sprintf(level_2_buf,"Level: %ld", level_2);
	sprintf(next_score_2_buf,"Next High Score:%ld",high_scores[9].score);
   }
else {
	sprintf(lines_1_buf,"Lineas a completar: %ld", lines_1);
	sprintf(total_lines_1_buf,"Lineas totales: %ld", total_lines_1);
	sprintf(level_1_buf,"Nivel: %ld", level_1);
	sprintf(score_1_buf,"Puntos: %ld", score_1);
	sprintf(next_score_1_buf,"Proximo record:%ld",high_scores[9].score);
	sprintf(lines_2_buf,"Lineas a completar: %ld", lines_2);
	sprintf(total_lines_2_buf,"Lineas totales: %ld", total_lines_2);
	sprintf(level_2_buf,"Nivel: %ld", level_2);
	sprintf(score_2_buf,"Puntos: %ld", score_2);
	sprintf(next_score_2_buf,"Proximo record:%ld",high_scores[9].score);
	}

ficha_nueva_1();
ficha_nueva_2();
ficha_nueva_1();
ficha_nueva_2();

/*
// Now we clean the statistics buffer
for(yb=0;yb<2;yb++)
	for(xb=0;xb<7;xb++)
   	statistics[yb][xb]=0;
*/

ficha_x1=5;ficha_y1=1;
ficha_x2=5;ficha_y2=1;

clear_keybuf();
count_old=tick_counter;
last_move=tick_counter;
last_rotate=tick_counter;
count_old_2=tick_counter;
last_move_2=tick_counter;
last_rotate_2=tick_counter;

pierde_ambos=0;
pierde_1=0,speed_1=30;
pierde_2=0,speed_2=30;

dibuja_ficha();
dibuja_tablero_1();
dibuja_ficha_2();
dibuja_tablero_2();

start++;
// Again, but for 2 players
while(!key[KEY_ESC] && pierde_ambos<2){
        hot_keys();
        if(key[TECLA_PAUSE]) pausa();
        if(key[TECLA_1_UP] && last_rotate<tick_counter && pierde_1==0){
                choque_frame();
                last_rotate=tick_counter+5;
                }
        if(key[TECLA_1_RIGHT] && last_move<tick_counter && pierde_1==0){
                desp_x1=+1;
                choque_h();
                last_move=tick_counter+3;
                }
        if(key[TECLA_1_LEFT] && last_move<tick_counter && pierde_1==0){
                desp_x1=-1;
                choque_h();
                last_move=tick_counter+3;
                }
        if(key[TECLA_1_DOWN] && count_old+1<tick_counter && pierde_1==0) count_old-= speed_1;
        if(count_old+speed_1<tick_counter && pierde_1==0){
                choque_abajo();
                count_old=tick_counter;
                }
        if(key[TECLA_2_UP] && last_rotate_2<tick_counter && pierde_2==0){
                choque_frame_2();
                last_rotate_2=tick_counter+5;
                }
        if(key[TECLA_2_RIGHT] && last_move_2<tick_counter && pierde_2==0){
                desp_x2=+1;
                choque_h_2();
                last_move_2=tick_counter+3;
                }
        if(key[TECLA_2_LEFT] && last_move_2<tick_counter && pierde_2==0){
                desp_x2=-1;
                choque_h_2();
                last_move_2=tick_counter+3;
                }
        if(key[TECLA_2_DOWN] && count_old_2+1<tick_counter && pierde_2==0) count_old_2-= speed_2;
        if(count_old_2+speed_2<tick_counter && pierde_2==0){
                choque_abajo_2();
                count_old_2=tick_counter;
                }
        }

if(pierde_1!=0 && pierde_2!=0){
	clear_keybuf;
	count_old=tick_counter+(30*7.5);
	while(count_old>tick_counter);
   }

//show_statistics(2);

while(1==1){
	if(score_1<high_scores[9].score && score_2<high_scores[9].score){
		print_high_scores(3);
      break;
	   }
	if(score_1>=high_scores[9].score && score_2<high_scores[9].score){
		got_score(1);
		print_high_scores(2);
      break;
	   }
	if(score_1>=high_scores[9].score && score_2>=high_scores[9].score){
		got_score(1);
		if(score_2>=high_scores[9].score){
	   	got_score(2);
	      print_high_scores(0);
	      break;
	      }
		else {
			print_high_scores(2);
	      break;
			}
	   }
	if(score_1<high_scores[9].score && score_2>=high_scores[9].score){
		got_score(2);
		print_high_scores(1);
      break;
	   }
   }

clear_keybuf();
while(!keypressed()) hot_keys();
stop_sample(datafile[RISA].dat);

}

/* This grows the cake of the second player when the first one has made the
 * required number of death lines.
 */
void sube_2(int lin)
{
	int x,y,error=0;

last_1+=lin;
while(last_1>=death_lines && pierde_2==0){
if(last_1>=death_lines && pierde_2==0) {
	last_1-=death_lines;


   play_sample(datafile[UNA_MAS].dat,255,128,1000,0);
	borra_ficha_2();

	for(y=0;y<19;y++)
   	for(x=1;x<11;x++)
      	vacio_2[y][x]=vacio_2[y+1][x];

	for(x=1;x<11;x++)
   	vacio_2[19][x]=random()%7;
	  	vacio_2[19][random()%10]=0;


	for(y=0;y<4;y++)
		for(x=0;x<4;x++)
			if(ficha_2[frame_2][y][x]!=0 && vacio_2[y+ficha_y2][x+ficha_x2]!=0)
         	error++;

	if(error!=0){
		ficha_y2--;
		dibuja_ficha_2();
      lineas_2();
      ficha_y2=1;
      ficha_x2=5;
      ficha_nueva_2();
      frame_2=0;
      dibuja_ficha_2();
      dibuja_tablero_2();
      play_sample(datafile[LINE].dat,255,128,1000,0);
      }
	else {
		dibuja_ficha_2();
      dibuja_tablero_2();
      }
   }
}
}

// Imagine...
void sube_1(int lin)
{
	int x,y,error=0;

last_2+=lin;
while(last_2>=death_lines && pierde_1==0){
if(last_2>=death_lines && pierde_1==0) {
	last_2-=death_lines;

   play_sample(datafile[UNA_MAS].dat,255,128,1000,0);
	borra_ficha();

	for(y=0;y<19;y++)
   	for(x=1;x<11;x++)
      	vacio_1[y][x]=vacio_1[y+1][x];

	for(x=1;x<11;x++)
   	vacio_1[19][x]=random()%7;
   	vacio_1[19][random()%10]=0;

	for(y=0;y<4;y++)
		for(x=0;x<4;x++)
			if(ficha[frame][y][x]!=0 && vacio_1[y+ficha_y1][x+ficha_x1]!=0)
         	error++;

	if(error!=0){
		ficha_y1--;
		dibuja_ficha();
      lineas_1();
      ficha_y1=1;
      ficha_x1=5;
      ficha_nueva_1();
      frame=0;
      dibuja_ficha();
      dibuja_tablero_1();
      play_sample(datafile[LINE].dat,255,128,1000,0);
      }
	else {
		dibuja_ficha();
      dibuja_tablero_1();
      }
   }
}
}

// This gets a new block for the first player.
ficha_nueva_1(void)
{
int f,yb,xb,ran,choq=0;

ran=order_of_blocks[random_counter_1];
random_counter_1++;
if(random_counter_1>249999)random_counter_1=0;

for(f=0;f<frames_prox;f++)
  for(yb=0;yb<4;yb++)
    for(xb=0;xb<4;xb++)
      ficha[f][yb][xb]=ficha_prox[f][yb][xb];
frames_ficha=frames_prox;

//update_statistics(1);

switch(ran){
  case 0:
      for(f=0;f<frames_s;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox[f][yb][xb]=ficha_s[f][yb][xb];
            }
          }
        }
      frames_prox=frames_s;
    break;
  case 1:
      for(f=0;f<frames_o;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox[f][yb][xb]=ficha_o[f][yb][xb];
            }
          }
        }
      frames_prox=frames_o;
    break;
  case 2:
      for(f=0;f<frames_z;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox[f][yb][xb]=ficha_z[f][yb][xb];
            }
          }
        }
      frames_prox=frames_z;
    break;
  case 3:
      for(f=0;f<frames_c;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox[f][yb][xb]=ficha_c[f][yb][xb];
            }
          }
        }
      frames_prox=frames_c;
    break;
  case 4:
      for(f=0;f<frames_l;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox[f][yb][xb]=ficha_l[f][yb][xb];
            }
          }
        }
      frames_prox=frames_l;
    break;
  case 5:
      for(f=0;f<frames_j;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox[f][yb][xb]=ficha_j[f][yb][xb];
            }
          }
        }
      frames_prox=frames_j;
    break;
  case 6:
      for(f=0;f<frames_i;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox[f][yb][xb]=ficha_i[f][yb][xb];
            }
          }
        }
      frames_prox=frames_i;
    break;
  }

for(yb=0;yb<4;yb++)
  for(xb=0;xb<4;xb++)
    if(ficha[0][yb][xb]!=0 && vacio_1[yb+ficha_y1][xb+ficha_x1]!=0)choq++;

if(choq!=0 && start!=0){
	pierde_1++;
   pierde_ambos++;

	play_sample(datafile[RISA].dat,255,128,1000,0);
   }

}

ficha_nueva_2(void)
{
int f,yb,xb,ran,choq=0;

ran=order_of_blocks[random_counter_2];
random_counter_2++;
if(random_counter_2>249999)random_counter_2=0;

for(f=0;f<frames_prox_2;f++)
  for(yb=0;yb<4;yb++)
    for(xb=0;xb<4;xb++)
      ficha_2[f][yb][xb]=ficha_prox_2[f][yb][xb];
frames_ficha_2=frames_prox_2;

//update_statistics(2);

switch(ran){
  case 0:
      for(f=0;f<frames_s;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox_2[f][yb][xb]=ficha_s[f][yb][xb];
            }
          }
        }
      frames_prox_2=frames_s;
    break;
  case 1:
      for(f=0;f<frames_o;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox_2[f][yb][xb]=ficha_o[f][yb][xb];
            }
          }
        }
      frames_prox_2=frames_o;
    break;
  case 2:
      for(f=0;f<frames_z;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox_2[f][yb][xb]=ficha_z[f][yb][xb];
            }
          }
        }
      frames_prox_2=frames_z;
    break;
  case 3:
      for(f=0;f<frames_c;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox_2[f][yb][xb]=ficha_c[f][yb][xb];
            }
          }
        }
      frames_prox_2=frames_c;
    break;
  case 4:
      for(f=0;f<frames_l;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox_2[f][yb][xb]=ficha_l[f][yb][xb];
            }
          }
        }
      frames_prox_2=frames_l;
    break;
  case 5:
      for(f=0;f<frames_j;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox_2[f][yb][xb]=ficha_j[f][yb][xb];
            }
          }
        }
      frames_prox_2=frames_j;
    break;
  case 6:
      for(f=0;f<frames_i;f++){
        for(yb=0;yb<4;yb++){
          for(xb=0;xb<4;xb++){
            ficha_prox_2[f][yb][xb]=ficha_i[f][yb][xb];
            }
          }
        }
      frames_prox_2=frames_i;
    break;
  }

for(yb=0;yb<4;yb++)
  for(xb=0;xb<4;xb++)
    if(ficha_2[0][yb][xb]!=0 && vacio_2[yb+ficha_y2][xb+ficha_x2]!=0)choq++;

if(choq!=0 && start!=0){
	pierde_2++;
   pierde_ambos++;

	play_sample(datafile[RISA].dat,255,128,1000,0);
   }
}

// We look if the player can rotate the piece, this is, change the frame.
choque_frame(void)
{
int x,y,choque=0,f;

borra_ficha();
if(frame==frames_ficha-1) f=0;
else f=frame+1;

for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha[f][y][x]!=0 && vacio_1[y+ficha_y1][x+ficha_x1]!=0)choque++;

if(choque==0){
        frame=f;
        dibuja_ficha();
        dibuja_tablero_1();
        play_sample(datafile[ROTATE].dat,255,128,1000,0);
        }
else {
        dibuja_ficha();
        dibuja_tablero_1();
        }
}

choque_frame_2(void)
{
int x,y,choque=0,f;

borra_ficha_2();
if(frame_2==frames_ficha_2-1) f=0;
else f=frame_2+1;

for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha_2[f][y][x]!=0 && vacio_2[y+ficha_y2][x+ficha_x2]!=0)choque++;

if(choque==0){
        frame_2=f;
        dibuja_ficha_2();
        dibuja_tablero_2();
        play_sample(datafile[ROTATE].dat,255,128,1000,0);
        }
else {
        dibuja_ficha_2();
        dibuja_tablero_2();
        }
}

// We look if the player can move the piece left or right
choque_h(void)
{
int x,y,choque=0;

borra_ficha();
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha[frame][y][x]!=0 && vacio_1[y+ficha_y1][x+ficha_x1+desp_x1]!=0)choque++;

if(choque==0){
        ficha_x1+=desp_x1;
        dibuja_ficha();
        dibuja_tablero_1();
        }
else {
        dibuja_ficha();
        dibuja_tablero_1();
        }
}

choque_h_2(void)
{
int x,y,choque=0;

borra_ficha_2();
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha_2[frame_2][y][x]!=0 && vacio_2[y+ficha_y2][x+ficha_x2+desp_x2]!=0)choque++;

if(choque==0){
        ficha_x2+=desp_x2;
        dibuja_ficha_2();
        dibuja_tablero_2();
        }
else {
        dibuja_ficha_2();
        dibuja_tablero_2();
        }
}

// This erases the block from the arena
borra_ficha(void)
{
int x,y;
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha[frame][y][x]!=0)vacio_1[y+ficha_y1][x+ficha_x1]=0;
}

borra_ficha_2(void)
{
int x,y;
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha_2[frame_2][y][x]!=0)vacio_2[y+ficha_y2][x+ficha_x2]=0;
}

// We look if the block can fall more or has reached the bottom of the arena
choque_abajo(void)
{
int x,y,choque=0;

borra_ficha();
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha[frame][y][x]!=0 && vacio_1[y+ficha_y1+1][x+ficha_x1]!=0)choque++;

if(choque>0){
        dibuja_ficha();
        dibuja_tablero_1();
        lineas_1();
        ficha_y1=1;
        ficha_x1=5;
        ficha_nueva_1();
        frame=0;
        dibuja_ficha();
        dibuja_tablero_1();
        play_sample(datafile[LINE].dat,255,128,1000,0);
        }
else {
        ficha_y1++;
        dibuja_ficha();
        dibuja_tablero_1();
        }
}

choque_abajo_2(void)
{
int x,y,choque=0;

borra_ficha_2();
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha_2[frame_2][y][x]!=0 && vacio_2[y+ficha_y2+1][x+ficha_x2]!=0)choque++;

if(choque>0){
        dibuja_ficha_2();
        dibuja_tablero_2();
        lineas_2();
        ficha_y2=1;
        ficha_x2=5;
        ficha_nueva_2();
        frame_2=0;
        dibuja_ficha_2();
        dibuja_tablero_2();
        play_sample(datafile[LINE].dat,255,128,1000,0);
        }
else {
        ficha_y2++;
        dibuja_ficha_2();
        dibuja_tablero_2();
        }
}

// Analog to borra_ficha(), this draws the piece on the arena 'buffer'
dibuja_ficha(void)
{
int x,y;
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha[frame][y][x]!=0)vacio_1[y+ficha_y1][x+ficha_x1]=ficha[frame][y][x];
}

dibuja_ficha_2(void)
{
int x,y;
for(y=0;y<4;y++)
  for(x=0;x<4;x++)
    if(ficha_2[frame_2][y][x]!=0)vacio_2[y+ficha_y2][x+ficha_x2]=ficha_2[frame_2][y][x];
}

// We look if the player made a full line and modify the score and so...
lineas_1(void)
{
int x,y,linea[4][1]={0,0,0,0},lin=0,bucle,cuantas=0;

for(y=0;y<20;y++){
        if(vacio_1[y][1]!=0 && vacio_1[y][2]!=0 && vacio_1[y][3]!=0 &&
           vacio_1[y][4]!=0 && vacio_1[y][5]!=0 && vacio_1[y][6]!=0 && 
           vacio_1[y][7]!=0 && vacio_1[y][8]!=0 && vacio_1[y][9]!=0 && 
           vacio_1[y][10]!=0){
                   linea[lin][0]=y;
                   lin++;
                   }
        }

for(bucle=0;bucle<lin;bucle++){
  for(x=1;x<11;x++)vacio_1[ linea[bucle][0] ][x]=0;
  for(;linea[bucle][0]>0;linea[bucle][0]--){
    for(x=1;x<11;x++) {
      vacio_1[linea[bucle][0]][x]=vacio_1[linea[bucle][0]-1][x];
      }
    }
  }


lines_1-=lin;
total_lines_1+=lin;
if(lin==1)score_1+=10;
if(lin==2)score_1+=50;
if(lin==3)score_1+=125;
if(lin==4)score_1+=500;

if(lines_1<=0){
        lines_1+=10;
        level_1++;
        if(speed_1<5) speed_1--;
        else speed_1-=4;
        score_1+=1000;
        play_sample(datafile[LEVELUP].dat,255,128,1000,0);
			if(pierde_2==0 && death_match==1){
				level_2++;
            lines_2=10;
			   if(speed_2<5) speed_2--;
			   else speed_2-=4;
				dibuja_tablero_2();
			   }
        }

if(score_1>=high_scores[0].score) next_score_1=0;
else {
	for(x=0;x<9;x++){
		if(score_1>=high_scores[x+1].score){
      	next_score_1=high_scores[x].score;
         x+=10;
         }
      }
	}
if(next_score_1==0) {
	if (language==ENG)sprintf(next_score_1_buf,"You are the best!!!");
   else sprintf(next_score_1_buf,"Eres el mejor!!!");
   }
else {
	if(language==ENG)sprintf(next_score_1_buf,"Next High Score:%ld",next_score_1);
   else sprintf(next_score_1_buf,"Proximo record:%ld",next_score_1);
   }

if(death_match==1)sube_2(lin);

blit(virtual,screen,0,0,0,0,397,320);
blit(virtual,screen,0,319,0,319,262,160);
if(lin!=0)play_sample(datafile[MAKELINE].dat,255,128,1000,0);
if(lin==4)play_sample(datafile[FOURLINES].dat,255,128,1000,0);
}

lineas_2(void)
{
int x,y,linea[4][1]={0,0,0,0},lin=0,bucle,cuantas=0;

for(y=0;y<20;y++){
        if(vacio_2[y][1]!=0 && vacio_2[y][2]!=0 && vacio_2[y][3]!=0 &&
           vacio_2[y][4]!=0 && vacio_2[y][5]!=0 && vacio_2[y][6]!=0 &&
           vacio_2[y][7]!=0 && vacio_2[y][8]!=0 && vacio_2[y][9]!=0 &&
           vacio_2[y][10]!=0){
                   linea[lin][0]=y;
                   lin++;
                   }
        }

for(bucle=0;bucle<lin;bucle++){
  for(x=1;x<11;x++)vacio_2[ linea[bucle][0] ][x]=0;
  for(;linea[bucle][0]>0;linea[bucle][0]--){
    for(x=1;x<11;x++) {
      vacio_2[linea[bucle][0]][x]=vacio_2[linea[bucle][0]-1][x];
      }
    }
  }


lines_2-=lin;
total_lines_2+=lin;
if(lin==1)score_2+=10;
if(lin==2)score_2+=50;
if(lin==3)score_2+=125;
if(lin==4)score_2+=500;

if(lines_2<=0){
        lines_2+=10;
        level_2++;
        if(speed_2<5) speed_2--;
        else speed_2-=4;
        score_2+=1000;
        play_sample(datafile[LEVELUP].dat,255,128,1000,0);
        if(pierde_1==0 && death_match==1){
	        level_1++;
           lines_1=10;
	        if(speed_1<5) speed_1--;
	        else speed_1-=4;
				dibuja_tablero_1();
			  }
        }


if(score_2>=high_scores[0].score) next_score_2=0;
else {
	for(x=0;x<9;x++){
		if(score_2>=high_scores[x+1].score){
      	next_score_2=high_scores[x].score;
         x+=10;
         }
      }
	}
if(next_score_2==0) {
	if (language==ENG)sprintf(next_score_2_buf,"You are the best!!!");
   else sprintf(next_score_2_buf,"Eres el mejor!!!");
   }
else {
	if(language==ENG)sprintf(next_score_2_buf,"Next High Score:%ld",next_score_2);
   else sprintf(next_score_2_buf,"Proximo record:%ld",next_score_2);
   }

if(death_match==1)sube_1(lin);

blit(virtual,screen,397,0,397,0,242,285);
blit(virtual,screen,251,285,251,285,388,286);
if(lin!=0)play_sample(datafile[MAKELINE].dat,255,128,1000,0);
if(lin==4)play_sample(datafile[FOURLINES].dat,255,128,1000,0);
}

/* Draws the arena buffer to the screen. Notice that we use the dirty rectan-
 * gle technic
 */
dibuja_tablero_1(void)
{
int x,y,temp1,temp2;

if(language==ENG){
	sprintf(lines_1_buf,"Lines to next level: %ld", lines_1);
	sprintf(total_lines_1_buf,"Total lines: %ld", total_lines_1);
	sprintf(level_1_buf,"Level: %ld", level_1);
	sprintf(score_1_buf,"Score: %ld", score_1);
	}
else {
	sprintf(lines_1_buf,"Lineas a completar: %ld", lines_1);
	sprintf(total_lines_1_buf,"Lineas totales: %ld", total_lines_1);
	sprintf(level_1_buf,"Nivel: %ld", level_1);
	sprintf(score_1_buf,"Puntos: %ld", score_1);
	}

for(y=0;y<20;y++){
	for(x=1;x<11;x++){
   	if(old_vacio_1[y][x]!=vacio_1[y][x]) {
			temp1=(19+(x-1)*22);temp2=(19+y*22);
         switch(vacio_1[y][x]){
         	case 0:
               blit(datafile[NADA].dat,virtual,0,0,temp1,temp2,22,22);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
         	case 1:
               draw_rle_sprite(virtual,datafile[AZUL].dat,temp1,temp2);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
         	case 2:
               draw_rle_sprite(virtual,datafile[NARANJA].dat,temp1,temp2);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
         	case 3:
               draw_rle_sprite(virtual,datafile[MARRON].dat,temp1,temp2);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
         	case 4:
               draw_rle_sprite(virtual,datafile[VERDE].dat,temp1,temp2);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
         	case 5:
               draw_rle_sprite(virtual,datafile[ROJO].dat,temp1,temp2);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
         	case 6:
               draw_rle_sprite(virtual,datafile[AMARILLO].dat,temp1,temp2);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
         	case 7:
               draw_rle_sprite(virtual,datafile[ROSA].dat,temp1,temp2);
               old_vacio_1[y][x]=vacio_1[y][x];
               break;
            }
         }
		}
	}

// Now we draw the next block... if the player wants to see it...
if(visible_blocks==1){
	for(y=0;y<2;y++){
	  for(x=0;x<4;x++){
      temp1=(19+(x+11)*22);temp2=140+y*22;
	    if(ficha_prox[0][y][x]==0)blit(background,virtual,temp1,temp2,temp1,temp2,22,22);
	    if(ficha_prox[0][y][x]==1)draw_rle_sprite(virtual,datafile[AZUL].dat,temp1,temp2);
	    if(ficha_prox[0][y][x]==2)draw_rle_sprite(virtual,datafile[NARANJA].dat,temp1,temp2);
	    if(ficha_prox[0][y][x]==3)draw_rle_sprite(virtual,datafile[MARRON].dat,temp1,temp2);
	    if(ficha_prox[0][y][x]==4)draw_rle_sprite(virtual,datafile[VERDE].dat,temp1,temp2);
	    if(ficha_prox[0][y][x]==5)draw_rle_sprite(virtual,datafile[ROJO].dat,temp1,temp2);
	    if(ficha_prox[0][y][x]==6)draw_rle_sprite(virtual,datafile[AMARILLO].dat,temp1,temp2);
	    if(ficha_prox[0][y][x]==7)draw_rle_sprite(virtual,datafile[ROSA].dat,temp1,temp2);
	    }
	  }
	}

// Print the scores...
rectfill(virtual,251,20,381,130,0);
if(language==ENG)textout(virtual,datafile[BIG_FONT].dat,"PLAYER 1",261,20,21);
else textout(virtual,datafile[BIG_FONT].dat,"JUGAD. 1",261,20,21);
textout(virtual,datafile[SMALL_FONT].dat,level_1_buf,261,50,21);
textout(virtual,datafile[SMALL_FONT].dat,lines_1_buf,261,65,21);
textout(virtual,datafile[SMALL_FONT].dat,total_lines_1_buf,261,80,21);
textout(virtual,datafile[SMALL_FONT].dat,score_1_buf,261,95,21);
textout(virtual,datafile[SMALL_FONT].dat,next_score_1_buf,261,110,21);

if(pierde_1!=0){
	text_mode(0);
   if(language==ENG)textout(virtual,datafile[BIG_FONT].dat,"GAME OVER !",59,100,1);
   else textout(virtual,datafile[BIG_FONT].dat,"PERDISTE !!",59,100,1);
	text_mode(-1);
   }

blit(virtual,screen,0,0,0,0,397,320);
blit(virtual,screen,0,319,0,319,262,160);
}

// The same, but different player
dibuja_tablero_2(void)
{
int x,y,temp1,temp2;

if(language==ENG){
	sprintf(lines_2_buf,"Lines to next level: %ld", lines_2);
	sprintf(total_lines_2_buf,"Total lines: %ld", total_lines_2);
	sprintf(level_2_buf,"Level: %ld", level_2);
	sprintf(score_2_buf,"Score: %ld", score_2);
	}
else {
	sprintf(lines_2_buf,"Lineas a completar: %ld", lines_2);
	sprintf(total_lines_2_buf,"Lineas totales: %ld", total_lines_2);
	sprintf(level_2_buf,"Nivel: %ld", level_2);
	sprintf(score_2_buf,"Puntos: %ld", score_2);
	}

for(y=0;y<20;y++){
	for(x=1;x<11;x++){
   	if(old_vacio_2[y][x]!=vacio_2[y][x]) {
			temp2=(19+y*22);temp1=(397+(x-1)*22);
         switch(vacio_2[y][x]){
         	case 0:
               blit(datafile[NADA].dat,virtual,0,0,temp1,temp2,22,22);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
         	case 1:
               draw_rle_sprite(virtual,datafile[AZUL].dat,temp1,temp2);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
         	case 2:
               draw_rle_sprite(virtual,datafile[NARANJA].dat,temp1,temp2);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
         	case 3:
               draw_rle_sprite(virtual,datafile[MARRON].dat,temp1,temp2);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
         	case 4:
               draw_rle_sprite(virtual,datafile[VERDE].dat,temp1,temp2);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
         	case 5:
               draw_rle_sprite(virtual,datafile[ROJO].dat,temp1,temp2);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
         	case 6:
               draw_rle_sprite(virtual,datafile[AMARILLO].dat,temp1,temp2);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
         	case 7:
               draw_rle_sprite(virtual,datafile[ROSA].dat,temp1,temp2);
               old_vacio_2[y][x]=vacio_2[y][x];
               break;
            }
         }
		}
	}

if(visible_blocks==1){
	for(y=0;y<2;y++){
	  for(x=0;x<4;x++){
      temp1=(19+(x+11)*22);temp2=412+y*22;
	    if(ficha_prox_2[0][y][x]==0)blit(background,virtual,temp1,temp2,temp1,temp2,22,22);
	    if(ficha_prox_2[0][y][x]==1)draw_rle_sprite(virtual,datafile[AZUL].dat,temp1,temp2);
	    if(ficha_prox_2[0][y][x]==2)draw_rle_sprite(virtual,datafile[NARANJA].dat,temp1,temp2);
	    if(ficha_prox_2[0][y][x]==3)draw_rle_sprite(virtual,datafile[MARRON].dat,temp1,temp2);
	    if(ficha_prox_2[0][y][x]==4)draw_rle_sprite(virtual,datafile[VERDE].dat,temp1,temp2);
	    if(ficha_prox_2[0][y][x]==5)draw_rle_sprite(virtual,datafile[ROJO].dat,temp1,temp2);
	    if(ficha_prox_2[0][y][x]==6)draw_rle_sprite(virtual,datafile[AMARILLO].dat,temp1,temp2);
	    if(ficha_prox_2[0][y][x]==7)draw_rle_sprite(virtual,datafile[ROSA].dat,temp1,temp2);
	    }
	  }
	}

rectfill(virtual,251,285,381,400,0);
if(language==ENG)textout(virtual,datafile[BIG_FONT].dat,"PLAYER 2",261,290,21);
else textout(virtual,datafile[BIG_FONT].dat,"JUGAD. 2",261,290,21);
textout(virtual,datafile[SMALL_FONT].dat,level_2_buf,261,320,21);
textout(virtual,datafile[SMALL_FONT].dat,lines_2_buf,261,335,21);
textout(virtual,datafile[SMALL_FONT].dat,total_lines_2_buf,261,350,21);
textout(virtual,datafile[SMALL_FONT].dat,score_2_buf,261,365,21);
textout(virtual,datafile[SMALL_FONT].dat,next_score_2_buf,261,380,21);

if(pierde_2!=0){
   text_mode(0);
   if(language==ENG)textout(virtual,datafile[BIG_FONT].dat,"GAME OVER !",437,100,1);
   else textout(virtual,datafile[BIG_FONT].dat,"PERDISTE !!",437,100,1);
	text_mode(-1);
}

blit(virtual,screen,397,0,397,0,242,285);
blit(virtual,screen,251,285,251,285,388,286);
}


// This draws one of the 3 extra menu screens.
void draw_menu(int which)
{
switch(which){
	case 0:
   	blit(background,virtual,0,0,0,0,640,480);
		draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
      if(language==ENG){
			textout(virtual,datafile[BIG_FONT].dat,"1 PLAYER",264,179,8);
			textout(virtual,datafile[BIG_FONT].dat,"2 PLAYERS",264,179+25,8);
			textout(virtual,datafile[BIG_FONT].dat,"OPTIONS",264,179+50,8);
			textout(virtual,datafile[BIG_FONT].dat,"VIEW HIGH SCORES",264,179+75,8);
			textout(virtual,datafile[BIG_FONT].dat,"EXIT GAME",264,179+100,8);
			textout_centre(virtual,datafile[BIG_FONT].dat,"Press F1 for help",320,430,8);
			textout_centre(virtual,font,"Made by Grzegorz Adam Hankiewicz, 1997",320,460,1);
			textout_centre(virtual,font,"Special thanks to DJ Delorie, Shawn Hargreaves and Robert Hhne",320,470,1);
         }
      else {
			textout(virtual,datafile[BIG_FONT].dat,"1 JUGADOR",264,179,8);
			textout(virtual,datafile[BIG_FONT].dat,"2 JUGADORES",264,179+25,8);
			textout(virtual,datafile[BIG_FONT].dat,"OPCIONES",264,179+50,8);
			textout(virtual,datafile[BIG_FONT].dat,"VER RECORDS",264,179+75,8);
			textout(virtual,datafile[BIG_FONT].dat,"SALIR DEL JUEGO",264,179+100,8);
			textout_centre(virtual,datafile[BIG_FONT].dat,"Pulsa F1 para ver la ayuda",320,430,8);
			textout_centre(virtual,font,"Creado por Grzegorz Adam Hankiewicz, 1997",320,460,1);
			textout_centre(virtual,font,"Gracias especiales a DJ Delorie, Shawn Hargreaves y Robert Hhne",320,470,1);
         }
		draw_rle_sprite(virtual,datafile[POINTER].dat,pos_x,pos_y);
      break;
	case 1:
   	if(language==ENG){
	      if(death_match==1)sprintf(buffer_mode,"DEATHMATCH MODE!!!");
	      else sprintf(buffer_mode,"NORMAL MODE");
	      sprintf(buffer_death_lines,"DEATH LINES : %d",death_lines);
	      if(visible_blocks==1)sprintf(buffer_blocks,"NEXT BLOCK SHOWED");
	      else sprintf(buffer_blocks,"NEXT BLOCK HIDDEN");
      	sprintf(language_buf,"TEXTS IN SPANISH");
	      if(death_match!=1)sprintf(buffer_death_lines,"DEATH LINES : ???");
         }
      else {
	      if(death_match==1)sprintf(buffer_mode,"MODO ASESINO !!!");
	      else sprintf(buffer_mode,"MODO NORMAL");
	      sprintf(buffer_death_lines,"LINEAS DE LA MUERTE : %d",death_lines);
	      if(visible_blocks==1)sprintf(buffer_blocks,"PROXIMA FICHA VISIBLE");
	      else sprintf(buffer_blocks,"PROXIMA FICHA OCULTA");
      	sprintf(language_buf,"TEXTOS EN INGLES");
	      if(death_match!=1)sprintf(buffer_death_lines,"LINEAS DE LA MUERTE : ???");
         }

   	blit(background,virtual,0,0,0,0,640,480);
		draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
		textout(virtual,datafile[BIG_FONT].dat,buffer_mode,264,179+25,8);
		textout(virtual,datafile[BIG_FONT].dat,buffer_death_lines,264,179+50,8);
		textout(virtual,datafile[BIG_FONT].dat,buffer_blocks,264,179+75,8);
		textout(virtual,datafile[BIG_FONT].dat,language_buf,264,179+125,8);
      if(language==ENG){
			textout(virtual,datafile[BIG_FONT].dat,"SOUND OPTIONS",264,179,8);
			textout(virtual,datafile[BIG_FONT].dat,"REDEFINE KEYS",264,179+100,8);
			textout(virtual,datafile[BIG_FONT].dat,"BACK",264,179+150,8);
			textout_centre(virtual,datafile[BIG_FONT].dat,"Press F1 for help",320,430,8);
			textout_centre(virtual,font,"Made by Grzegorz Adam Hankiewicz, 1997",320,460,1);
			textout_centre(virtual,font,"Special thanks to DJ Delorie, Shawn Hargreaves and Robert Hhne",320,470,1);
         }
      else {
			textout(virtual,datafile[BIG_FONT].dat,"CONTROLES DE SONIDO",264,179,8);
			textout(virtual,datafile[BIG_FONT].dat,"REDEFINIR TECLAS",264,179+100,8);
			textout(virtual,datafile[BIG_FONT].dat,"VOLVER",264,179+150,8);
			textout_centre(virtual,datafile[BIG_FONT].dat,"Pulsa F1 para ver la ayuda",320,430,8);
			textout_centre(virtual,font,"Creado por Grzegorz Adam Hankiewicz, 1997",320,460,1);
			textout_centre(virtual,font,"Gracias especiales a DJ Delorie, Shawn Hargreaves y Robert Hhne",320,470,1);
         }
		draw_rle_sprite(virtual,datafile[POINTER].dat,pos_x,pos_y);
      break;
	case 2:
      if(language==ENG){
			sprintf(buffer_vol_fx,"FX VOLUME : %d", vol_fx);
	      sprintf(buffer_vol_midi,"MUSIC VOLUME : %d", vol_midi);
         }
      else {
			sprintf(buffer_vol_fx,"VOLUMEN DEL SONIDO FX : %d", vol_fx);
	      sprintf(buffer_vol_midi,"VOLUMEN DE LA MUSICA: %d", vol_midi);
         }

	  	blit(background,virtual,0,0,0,0,640,480);
		draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
		textout(virtual,datafile[BIG_FONT].dat,buffer_vol_fx,264,179,8);
		textout(virtual,datafile[BIG_FONT].dat,buffer_vol_midi,264,179+25,8);
		textout(virtual,datafile[BIG_FONT].dat,buffer_music_num,264,179+50,8);
		textout_centre(virtual,datafile[BIG_FONT].dat,buffer_music_title,320,179+175,8);
      if(language==ENG){
			textout(virtual,datafile[BIG_FONT].dat,"BACK",264,179+75,8);
			textout_centre(virtual,datafile[BIG_FONT].dat,"Pulsa F1 para ver la ayuda",320,430,8);
			textout_centre(virtual,font,"Made by Grzegorz Adam Hankiewicz, 1997",320,460,1);
			textout_centre(virtual,font,"Special thanks to DJ Delorie, Shawn Hargreaves and Robert Hhne",320,470,1);
         }
      else {
			textout(virtual,datafile[BIG_FONT].dat,"VOLVER",264,179+75,8);
			textout_centre(virtual,datafile[BIG_FONT].dat,"Pulsa F1 para ver la ayuda",320,430,8);
			textout_centre(virtual,font,"Creado por Grzegorz Adam Hankiewicz, 1997",320,460,1);
			textout_centre(virtual,font,"Gracias especiales a DJ Delorie, Shawn Hargreaves y Robert Hhne",320,470,1);
         }
		draw_rle_sprite(virtual,datafile[POINTER].dat,pos_x,pos_y);
      break;
	}

blit(virtual,screen,0,0,0,0,640,480);
}

// We redefine the keys.
void redefine_keys(void)
{
int tecla=5000,counter_2;

play_sample(datafile[MOVE].dat,255,128,1000,0);

blit(background,virtual,0,0,0,0,640,480);
draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);

if(language==ENG){
	textout_centre(virtual,datafile[BIG_FONT].dat,"PRESS D TO USE DEFAULT KEYS",320,200,8);
	textout_centre(virtual,datafile[BIG_FONT].dat,"PRESS ANY OTHER TO REDEFINE KEYS",320,240,8);
   }
else {
	textout_centre(virtual,datafile[BIG_FONT].dat,"PULSA LA D PARA USAR LAS TECLAS PREDEFINIDAS",320,200,8);
	textout_centre(virtual,datafile[BIG_FONT].dat,"PULSA CUALQUIER OTRA PARA REDEFINIRLAS",320,240,8);
   }
blit(virtual,screen,0,0,0,0,640,480);
clear_keybuf();

while((tecla=readkey())==5000);
if((tecla >> 8)==32)
	{
	TECLA_1_UP=17,TECLA_1_DOWN=31,TECLA_1_LEFT=30,TECLA_1_RIGHT=32,
	TECLA_2_UP=72,TECLA_2_DOWN=80,TECLA_2_LEFT=75,TECLA_2_RIGHT=77,
   TECLA_MUSIC=50,TECLA_PAUSE=25;
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
   if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"DEFAULT KEYS SET",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"TECLAS PREDEFINIDAS RECUPERADAS",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	play_sample(datafile[MOVE].dat,255,128,1000,0);
   counter_2=tick_counter;
   do{}while(!keypressed() && counter_2+60>tick_counter);
   }
else
	{
	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 1. PRESS A KEY FOR LEFT",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 1. PULSA UNA TECLA PARA IZQUIERDA",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_1_LEFT=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 1. PRESS A KEY FOR RIGHT",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 1. PULSA UNA TECLA PARA DERECHA",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_1_RIGHT=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 1. PRESS A KEY FOR ROTATE",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 1. PULSA UNA TECLA PARA ROTAR",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_1_UP=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 1. PRESS A KEY FOR DOWN",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 1. PULSA UNA TECLA PARA BAJAR",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_1_DOWN=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 2. PRESS A KEY FOR LEFT",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 2. PULSA UNA TECLA PARA IZQUIERDA",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_2_LEFT=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 2. PRESS A KEY FOR RIGHT",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 2. PULSA UNA TECLA PARA DERECHA",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_2_RIGHT=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 2. PRESS A KEY FOR ROTATE",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 2. PULSA UNA TECLA PARA ROTAR",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_2_UP=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PLAYER 2. PRESS A KEY FOR DOWN",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"JUGADOR 2. PULSA UNA TECLA PARA BAJAR",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_2_DOWN=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PRESS A KEY FOR SWITCHING MUSIC",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"PULSA UNA TECLA PARA CAMBIAR LA MUSICA",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_MUSIC=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
	blit(background,virtual,0,0,0,0,640,480);
	draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);
	if(language==ENG)textout_centre(virtual,datafile[BIG_FONT].dat,"PRESS A KEY FOR PAUSE",320,220,8);
   else textout_centre(virtual,datafile[BIG_FONT].dat,"PULSA UNA TECLA PARA LA PAUSA",320,220,8);
	blit(virtual,screen,0,0,0,0,640,480);
	clear_keybuf();
   TECLA_PAUSE=readkey() >> 8;

	play_sample(datafile[MOVE].dat,255,128,1000,0);
   }

}

// Menu of sound and music.
void third_menu(void)
{
int end_loop=0;
pos_y=178;
draw_menu(2);
play_sample(datafile[MOVE].dat,255,128,1000,0);
clear_keybuf();

while(!key[KEY_ESC] && end_loop==0)
{
   if(key[KEY_F12] || key[KEY_F10]) capture_screen();
   if(midi_pos==-1 || key[TECLA_MUSIC]){
		music(0);
      draw_menu(2);
      }
	if(key[KEY_F5]){
	   vol_fx--;
		if(vol_fx<0)vol_fx=0;
	   set_volume(vol_fx,vol_midi);
      stop_sample(datafile[MOVE].dat);
	   play_sample(datafile[MOVE].dat,255,128,1000,0);
      draw_menu(2);
	   }
	if(key[KEY_F6]){
	   vol_fx++;
		if(vol_fx>255)vol_fx=255;
	   set_volume(vol_fx,vol_midi);
      stop_sample(datafile[MOVE].dat);
	   play_sample(datafile[MOVE].dat,255,128,1000,0);
      draw_menu(2);
	   }
	if(key[KEY_F7]){
	   vol_midi--;
		if(vol_midi<0)vol_midi=0;
	   set_volume(vol_fx,vol_midi);
      draw_menu(2);
	   }
	if(key[KEY_F8]){
	   vol_midi++;
		if(vol_midi>255)vol_midi=255;
	   set_volume(vol_fx,vol_midi);
      draw_menu(2);
	   }
	if(key[KEY_DOWN]){
		if(pos_y<252)pos_y+=25;
		else pos_y=178;
		draw_menu(2);
		play_sample(datafile[MOVE].dat,255,128,1000,0);
		while(key[KEY_DOWN]);
		}
	if(key[KEY_LEFT]){
   	switch(pos_y){
      	case 178:
            if(vol_fx>0){
            	vol_fx-=10;
            	if(vol_fx<0)vol_fx=0;
	            draw_menu(2);
					set_volume(vol_fx,vol_midi);
               play_sample(datafile[MOVE].dat,255,128,1000,0);
               while(key[KEY_LEFT]);
               }
            break;
      	case 203:
            if(vol_midi>0){
            	vol_midi-=10;
            	if(vol_midi<0)vol_midi=0;
	            draw_menu(2);
					set_volume(vol_fx,vol_midi);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               while(key[KEY_LEFT]);
               }
            break;
      	case 228:
				music(-1);
            draw_menu(2);
            while(key[KEY_LEFT]);
            break;
      	}
      }
	if(key[KEY_RIGHT]){
   	switch(pos_y){
      	case 178:
            if(vol_fx<255){
            	vol_fx+=10;
            	if(vol_fx>255)vol_fx=255;
	            draw_menu(2);
					set_volume(vol_fx,vol_midi);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               while(key[KEY_RIGHT]);
               }
            break;
      	case 203:
            if(vol_midi<255){
            	vol_midi+=10;
            	if(vol_midi>255)vol_midi=255;
	            draw_menu(2);
					set_volume(vol_fx,vol_midi);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               while(key[KEY_RIGHT]);
               }
            break;
      	case 228:
				music(+1);
            draw_menu(2);
            while(key[KEY_RIGHT]);
            break;
      	}
      }
	if(key[KEY_UP]){
		if(pos_y>178)pos_y-=25;
		else pos_y=253;
		draw_menu(2);
		play_sample(datafile[MOVE].dat,255,128,1000,0);
		while(key[KEY_UP]);
		}
	if(key[KEY_ENTER] || key[KEY_SPACE]){
		switch(pos_y){
			case 253:
         	end_loop++;
	         break;
			}
		}

	}
play_sample(datafile[MOVE].dat,255,128,1000,0);
pos_y=178;
}

// This is the options menu
void second_menu(void)
{
int end_loop=0;
pos_y=178;
draw_menu(1);
clear_keybuf();

while(!key[KEY_ESC] && end_loop==0)
{
   hot_keys();
	if(key[KEY_DOWN]){
		if(pos_y<328)pos_y+=25;
		else pos_y=178;
		draw_menu(1);
		play_sample(datafile[MOVE].dat,255,128,1000,0);
		while(key[KEY_DOWN]);
		}
	if(key[KEY_LEFT]){
   	switch(pos_y){
      	case 203:
            if(death_match!=0){
            	death_match=0;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               }
            break;
      	case 228:
            if(death_lines>1 && death_match==1){
            	death_lines--;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               while(key[KEY_LEFT]);
               }
            break;
      	case 253:
            if(visible_blocks!=0){
            	visible_blocks=0;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               }
            break;
      	case 303:
            if(language!=ENG){
            	language=ENG;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               }
            break;
      	}
      }
	if(key[KEY_RIGHT]){
   	switch(pos_y){
	     	case 203:
            if(death_match!=1){
            	death_match=1;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               }
            break;
      	case 228:
            if(death_lines<10 && death_match==1){
            	death_lines++;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               while(key[KEY_RIGHT]);
               }
            break;
      	case 253:
            if(visible_blocks!=1){
            	visible_blocks=1;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               }
            break;
      	case 303:
            if(language==ENG){
            	language=SPA;
	            draw_menu(1);
					play_sample(datafile[MOVE].dat,255,128,1000,0);
               }
            break;
      	}
      }
	if(key[KEY_UP]){
		if(pos_y>178)pos_y-=25;
		else pos_y=328;
		draw_menu(1);
		play_sample(datafile[MOVE].dat,255,128,1000,0);
		while(key[KEY_UP]);
		}
	if(key[KEY_ENTER] || key[KEY_SPACE]){
		switch(pos_y){
			case 178:
         	third_menu();
            draw_menu(1);
				clear_keybuf();
	         break;
			case 278:
            redefine_keys();
            draw_menu(1);
            clear_keybuf();
	         break;
			case 328:
         	end_loop++;
	         break;
			}
		}


	}

play_sample(datafile[MOVE].dat,255,128,1000,0);
pos_y=228;
}

void create_title(void)
{
	int x=0,color=162,counter_color=0;

   for(x=0;x<320;x++) {
   	vline(virtual,x,0,479,color);
      counter_color++;
      if(counter_color>=2){
      	counter_color=0;
         color--;
         }
      }

   for(x=320;x<640;x++) {
   	vline(virtual,x,0,479,color);
      counter_color++;
      if(counter_color>=2){
      	counter_color=0;
         color++;
         }
      }

}

/*
 * Here is the main() part of the program. From here, we control the menu of
 * the game.
 */

void main(int argc, char *argv[])
{
int end_loop=0,c,rrr=0;
FILE *file;

struct {
	char buffer[80];
   } text[18];

clrscr();
init_config();
if(language==ENG) {
	sprintf(text[0].buffer,"Initializing Allegro...");
   sprintf(text[1].buffer,"Gogosoftware presents: just another Tetris clone !");
	sprintf(text[2].buffer,"This game was compiled with");
   sprintf(text[3].buffer,"You are running this game under Windows 3.1");
   sprintf(text[4].buffer,"UGH! You are running this game under Windows 95 !");
   sprintf(text[5].buffer,"You are running this game under Linux DOSEMU");
   sprintf(text[6].buffer,"UGH! You are running this game under Windows NT !");
   sprintf(text[7].buffer,"...installing timer...");
   sprintf(text[8].buffer,"...installing keyboard...");
   sprintf(text[9].buffer,"Error initialising sound");
   sprintf(text[10].buffer,"...sound and music drivers succesfully installed...");
   sprintf(text[11].buffer,"Error loading file 'TETRIS.DAT'!");
   sprintf(text[12].buffer,"...data file loaded");
   sprintf(text[13].buffer,"Starting game. Press a key...");
   sprintf(text[14].buffer,"Error setting up video display");
   sprintf(text[15].buffer,"PRESENTS...");
   sprintf(text[16].buffer,"Made by Grzegorz Adam Hankiewicz, 1997");
   sprintf(text[17].buffer,"Special thanks to DJ Delorie, Shawn Hargreaves and Robert Hhne");
   }
else {
	sprintf(text[0].buffer,"Inicializando Allegro...");
   sprintf(text[1].buffer,"Gogosoftware presenta:  simplemente otro clon del Tetris !");
   sprintf(text[2].buffer,"Este juego se compil con");
   sprintf(text[3].buffer,"Estas ejecutando el juego desde Windows 3.1");
   sprintf(text[4].buffer,"UGH!  Ests ejecutando el juego desde Windows 95 !");
   sprintf(text[5].buffer,"Estas ejecutando el juego desde Linux DOSEMU");
   sprintf(text[6].buffer,"UGH!  Ests ejecutando el juego desde Windows NT !");
   sprintf(text[7].buffer,"...instalando cronmetro...");
   sprintf(text[8].buffer,"...instalando teclado...");
   sprintf(text[9].buffer,"Error inicializando el sonido");
   sprintf(text[10].buffer,"...controladores de sonido y musica instalados con xito...");
   sprintf(text[11].buffer,"Error cargando el fichero 'TETRIS.DAT'!");
   sprintf(text[12].buffer,"...fichero de datos cargado");
   sprintf(text[13].buffer,"Comenzando el juego. Pulsa una tecla...");
   sprintf(text[14].buffer,"Error de la tarjeta grfica");
   sprintf(text[15].buffer,"PRESENTA...");
   sprintf(text[16].buffer,"Creado por Grzegorz Adam Hankiewicz, 1997");
   sprintf(text[17].buffer,"Gracias especiales a DJ Delorie, Shawn Hargreaves y Robert Hhne");
   }

printf("%s\n\n",text[0].buffer);

allegro_init(); /* We initialise the Allegro lib. You HAVE to call this before
                 * everything else, or the game won't work
                 */

printf("%s\n\n",text[1].buffer);
printf("%s %s\n\n",text[2].buffer,allegro_id);
if(windows_version==3)printf("%s\n\n",text[3].buffer);
if(windows_version==4)printf("%s\n\n",text[4].buffer);
if(windows_version==-1)printf("%s\n\n",text[5].buffer);
if(windows_version==0x100)printf("%s\n\n",text[6].buffer);

printf("%s\n",text[8].buffer);
install_keyboard(); /* Installs the Allegro keyboard interrupt handler. You
                     * must call this before using any of the keyboard input
                     * routines. Once you have set up the Allegro handler,
                     * you can no longer use DOS/BIOS calls or C library
                     * functions to access the keyboard.
                     */

printf("%s\n",text[7].buffer);

install_timer(); /* Installs the Allegro timer interrupt handler. You must do
                  * this before installing any user timer routines, and also
                  * before displaying a mouse pointer, playing FLI anima-
                  * tions or MIDI music, and using any of the GUI routines.
                  */
/* The following is used to set up the timer we will use in the game. It will
 * help us to control the speed at which the game will run. Thanks to this,
 * future users in the year 3000 will be able to play it without going crazy
 * trying to 'see' the individual frames */

LOCK_VARIABLE(tick_counter);
LOCK_FUNCTION(inc_ticks);

install_int_ex(inc_ticks,BPS_TO_TIMER(SECOND));
// From now on, one second will be 30 'ticks' for us.

/* Now we will install the sound. We will allow Allegro to autodetect it. He
 * usually does it all right. If there's a mistake, we exit to DOS
 */

init_scores();

if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, argv[0]) != 0) {
	printf("\n%s\n%s\n\n", text[9].buffer,allegro_error);
   exit(1);
   }
else printf("%s\n",text[10].buffer);
set_volume(vol_fx,vol_midi);

// We will load the dat file which contains all the graphics/sounds/music.
datafile = load_datafile("tetris.dat");
if (!datafile) {
   allegro_exit();
   printf("%s\n\n",text[11].buffer);
   exit(1);
   }
else printf("%s\n\n\n\n%s\n",text[12].buffer,text[13].buffer);

for (c=1;c<argc;c++) {
	if (stricmp(argv[c], "-wait") == 0) rrr++;
	if (stricmp(argv[c], "-espera") == 0) rrr++;
   }

if(rrr!=0) wait(-1,-1);
fade_out(2);

if (set_gfx_mode(GFX_AUTODETECT,640,480,0,0)!=0) {
  	printf("%s\n%s\n",text[14].buffer,allegro_error);
   exit(1);
   }

// Create the screen buffers...
background=create_bitmap(640,480);
stretch_blit(datafile[BMP_MENU].dat,background,0,0,320,200,0,0,640,480);
virtual=create_bitmap(640,480);
pause_screen=create_bitmap(640,480);
set_palette(black_palette);

// Start with the wonderful intro...
stretch_blit(datafile[LOGO].dat,virtual,0,0,320,240,0,0,640,480);
blit(virtual,screen,0,0,0,0,640,480);
clear(virtual);
textout_centre(virtual,datafile[BIG_FONT].dat,text[15].buffer,320,220,255);

fade_in(datafile[PAL_LOGO].dat,4);

wait(SECOND*10,WITH_KEYPRESS);
fade_out(4);

blit(virtual,screen,0,0,0,0,640,480);

fade_in(datafile[PAL_TITLE].dat,4);
wait(SECOND*2,WITH_KEYPRESS);
fade_out(4);

clear(virtual);
create_title();
draw_rle_sprite(virtual,datafile[BMP_TITLE].dat,100,203);

text_mode(-1);

textout_centre(virtual,datafile[BIG_FONT].dat,"VERSION 1.1",320,430,0);
textout_centre(virtual,font,text[16].buffer,320,460,0);
textout_centre(virtual,font,text[17].buffer,320,470,0);

blit(virtual,screen,0,0,0,0,640,480);

blit(background,virtual,0,0,0,0,640,480);
draw_rle_sprite(virtual,datafile[BMP_TETRIS].dat,210,50);

play_sample(datafile[WELCOME].dat,255,128,1000,0);
fade_in(datafile[PAL_TITLE].dat,1);

wait(SECOND*10,WITH_KEYPRESS);
fade_out(1);

// The menu stuff comes here...
pos_y=178;
draw_menu(0);

fade_in(datafile[PAL_MAIN].dat,1);

clear_keybuf();
srandom(tick_counter);
create_pause_screen();

/* In the following loop we check the keys and move the pointer through the
 * screen.
 */
while(!key[KEY_ESC] && end_loop==0)
        {
        hot_keys();
        if(key[KEY_DOWN]){
                if(pos_y<278)pos_y+=25;
                else pos_y=178;
                draw_menu(0);
                play_sample(datafile[MOVE].dat,255,128,1000,0);
                while(key[KEY_DOWN]);
                }

        if(key[KEY_UP]){
                if(pos_y>178)pos_y-=25;
                else pos_y=278;
                draw_menu(0);
                play_sample(datafile[MOVE].dat,255,128,1000,0);
                while(key[KEY_UP]);
                }

        if(key[KEY_ENTER] || key[KEY_SPACE]){
                switch(pos_y){
                  case 278:
                    end_loop++;
                    break;
                  case 178:
                    blit(background,virtual,0,0,0,0,640,460);
                    blit(virtual,screen,0,0,0,0,640,480);
                    one_player();
                    draw_menu(0);
                    clear_keybuf();
                    break;
                  case 203:
                    blit(background,virtual,0,0,0,0,640,460);
                    blit(virtual,screen,0,0,0,0,640,480);
                    two_player();
                    draw_menu(0);
                    clear_keybuf();
                    break;
                  case 228:
                    play_sample(datafile[MOVE].dat,255,128,1000,0);
                    second_menu();
                    draw_menu(0);
                    clear_keybuf();
                    break;
                  case 253:
                    play_sample(datafile[MOVE].dat,255,128,1000,0);
                    print_high_scores(0);
                    while(key[KEY_ENTER]);
                    clear_keybuf();
                    while(!keypressed()) hot_keys();
                    draw_menu(0);
                    clear_keybuf();
                    break;
                  }
                }
        }

fade_out(10);
clear_keybuf();
set_gfx_mode(GFX_TEXT,0,0,0,0);
allegro_exit();

save_config();
save_scores();

// Show 'bye,bye' screen...
if(language==ENG){
printf("--------------------------------------------------------------------------------");
printf("That was a Tetris clone made by Grzegorz Adam Hankiewicz. Cool , eh? :-)\n");
printf("You can email me to gregorio@jet.es or check http://gogosoftware.base.org for\n");
printf("the latest news about my freeware games with source.\n");
printf("--------------------------------------------------------------------------------");
printf("This game was made thanks to the existence of several freeware programs:\n");
printf("DJGPP   : 32bits free C and C++ compiler made by DJ Delorie.\n");
printf("Allegro : Game library to help creating games made by Shawn Hargreaves.\n");
printf("Rhide   : IDE made by Robert Hhne. Maybe I could have used EDIT, but what\n");
printf("          the hell, it's also free and easy to use.\n");
printf("--------------------------------------------------------------------------------");
printf("Remember: THIS IS FREEWARE AND YOU HAVE TO COPY IT TO ALL YOUR FRIENDS!!!\n");
printf("--------------------------------------------------------------------------------");
printf("\nAnd don't forget to at least email me telling if you liked the game.\n\n");
}
else {
printf("--------------------------------------------------------------------------------");
printf("Eso era un clon del Tetris creado por Grzegorz Adam Hankiewicz. Guay, eh? :-)\n");
printf("Puedes emailearme a gregorio@jet.es o ir a http://gogosoftware.base.org para\n");
printf("conocer las tlimas noticias sobre mis juegos freeware con cdigo fuente.\n");
printf("--------------------------------------------------------------------------------");
printf("Este juego se hizo gracias a la esistencia de varios programas freeware:\n");
printf("DJGPP   : Compilador de C y C++ en 32bits hecho por DJ Delorie.\n");
printf("Allegro : Biblioteca que ayuda a crear juegos hecha por Shawn Hargreaves.\n");
printf("Rhide   : IDE hecho por Robert Hhne. Hubiese podido usar el EDIT, pero qu\n");
printf("          demonios, tambin es grtis y fcil de usar.\n");
printf("--------------------------------------------------------------------------------");
printf("Recuerda:  ESTE JUEGO ES FREEWARE Y LO TIENES QUE COPIAR A TODOS TUS AMIGOS !\n");
printf("--------------------------------------------------------------------------------");
printf("\nY no olvides mandarme un email contndome si te gust el juego.\n\n");
}

//End of game
}
